/*     */ package org.apache.batik.transcoder.image;
/*     */ 
/*     */ import java.awt.image.BufferedImage;
/*     */ import java.awt.image.SinglePixelPackedSampleModel;
/*     */ import org.apache.batik.bridge.UserAgent;
/*     */ import org.apache.batik.transcoder.TranscoderException;
/*     */ import org.apache.batik.transcoder.TranscoderOutput;
/*     */ import org.apache.batik.transcoder.TranscodingHints;
/*     */ import org.apache.batik.transcoder.keys.StringKey;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TIFFTranscoder
/*     */   extends ImageTranscoder
/*     */ {
/*  44 */   public TIFFTranscoder() { this.hints.put(KEY_FORCE_TRANSPARENT_WHITE, Boolean.FALSE); }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  49 */   public UserAgent getUserAgent() { return this.userAgent; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  58 */   public BufferedImage createImage(int width, int height) { return new BufferedImage(width, height, 2); }
/*     */ 
/*     */ 
/*     */   
/*     */   private WriteAdapter getWriteAdapter(String className) {
/*     */     try {
/*  64 */       Class clazz = Class.forName(className);
/*  65 */       return (WriteAdapter)clazz.newInstance();
/*     */     } catch (ClassNotFoundException e) {
/*     */       
/*  68 */       return null;
/*     */     } catch (InstantiationException e) {
/*  70 */       return null;
/*     */     } catch (IllegalAccessException e) {
/*  72 */       return null;
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void writeImage(BufferedImage img, TranscoderOutput output) throws TranscoderException {
/*  89 */     boolean forceTransparentWhite = false;
/*     */     
/*  91 */     if (this.hints.containsKey(ImageTranscoder.KEY_FORCE_TRANSPARENT_WHITE)) {
/*  92 */       forceTransparentWhite = ((Boolean)this.hints.get(ImageTranscoder.KEY_FORCE_TRANSPARENT_WHITE)).booleanValue();
/*     */     }
/*     */ 
/*     */ 
/*     */     
/*  97 */     if (forceTransparentWhite) {
/*     */       
/*  99 */       SinglePixelPackedSampleModel sppsm = (SinglePixelPackedSampleModel)img.getSampleModel();
/* 100 */       forceTransparentWhite(img, sppsm);
/*     */     } 
/*     */     
/* 103 */     WriteAdapter adapter = getWriteAdapter("org.apache.batik.ext.awt.image.codec.tiff.TIFFTranscoderInternalCodecWriteAdapter");
/*     */     
/* 105 */     if (adapter == null) {
/* 106 */       adapter = getWriteAdapter("org.apache.batik.transcoder.image.TIFFTranscoderImageIOWriteAdapter");
/*     */     }
/*     */     
/* 109 */     if (adapter == null) {
/* 110 */       throw new TranscoderException("Could not write TIFF file because no WriteAdapter is availble");
/*     */     }
/*     */     
/* 113 */     adapter.writeImage(this, img, output);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 175 */   public static final TranscodingHints.Key KEY_FORCE_TRANSPARENT_WHITE = ImageTranscoder.KEY_FORCE_TRANSPARENT_WHITE;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 198 */   public static final TranscodingHints.Key KEY_COMPRESSION_METHOD = new StringKey();
/*     */   
/*     */   public static interface WriteAdapter {
/*     */     void writeImage(TIFFTranscoder param1TIFFTranscoder, BufferedImage param1BufferedImage, TranscoderOutput param1TranscoderOutput) throws TranscoderException;
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-transcoder.jar!\org\apache\batik\transcoder\image\TIFFTranscoder.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */