/*      */ package org.apache.batik.transcoder.svg2svg;
/*      */ 
/*      */ import java.io.IOException;
/*      */ import java.io.Reader;
/*      */ import java.io.Writer;
/*      */ import java.util.LinkedList;
/*      */ import java.util.List;
/*      */ import org.apache.batik.transcoder.ErrorHandler;
/*      */ import org.apache.batik.transcoder.TranscoderException;
/*      */ import org.apache.batik.xml.XMLException;
/*      */ import org.apache.batik.xml.XMLScanner;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public class PrettyPrinter
/*      */ {
/*      */   public static final int DOCTYPE_CHANGE = 0;
/*      */   public static final int DOCTYPE_REMOVE = 1;
/*      */   public static final int DOCTYPE_KEEP_UNCHANGED = 2;
/*      */   protected XMLScanner scanner;
/*      */   protected OutputManager output;
/*      */   protected Writer writer;
/*   65 */   protected ErrorHandler errorHandler = SVGTranscoder.DEFAULT_ERROR_HANDLER;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*   70 */   protected String newline = "\n";
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected boolean format = true;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*   80 */   protected int tabulationWidth = 4;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*   85 */   protected int documentWidth = 80;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*   90 */   protected int doctypeOption = 2;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected String publicId;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected String systemId;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected String xmlDeclaration;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected int type;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  116 */   public void setXMLDeclaration(String s) { this.xmlDeclaration = s; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  123 */   public void setDoctypeOption(int i) { this.doctypeOption = i; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  130 */   public void setPublicId(String s) { this.publicId = s; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  137 */   public void setSystemId(String s) { this.systemId = s; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  144 */   public void setNewline(String s) { this.newline = s; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  151 */   public String getNewline() { return this.newline; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  158 */   public void setFormat(boolean b) { this.format = b; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  165 */   public boolean getFormat() { return this.format; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  172 */   public void setTabulationWidth(int i) { this.tabulationWidth = Math.max(i, 0); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  179 */   public int getTabulationWidth() { return this.tabulationWidth; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  186 */   public void setDocumentWidth(int i) { this.documentWidth = Math.max(i, 0); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  193 */   public int getDocumentWidth() { return this.documentWidth; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public void print(Reader r, Writer w) throws TranscoderException, IOException {
/*      */     try {
/*  202 */       this.scanner = new XMLScanner(r);
/*  203 */       this.output = new OutputManager(this, w);
/*  204 */       this.writer = w;
/*  205 */       this.type = this.scanner.next();
/*      */       
/*  207 */       printXMLDecl();
/*      */       
/*      */       while (true) {
/*  210 */         switch (this.type) {
/*      */           case 1:
/*  212 */             this.output.printTopSpaces(getCurrentValue());
/*  213 */             this.scanner.clearBuffer();
/*  214 */             this.type = this.scanner.next();
/*      */             continue;
/*      */           case 4:
/*  217 */             this.output.printComment(getCurrentValue());
/*  218 */             this.scanner.clearBuffer();
/*  219 */             this.type = this.scanner.next();
/*      */             continue;
/*      */           case 5:
/*  222 */             printPI();
/*      */             continue;
/*      */         } 
/*      */ 
/*      */         
/*      */         break;
/*      */       } 
/*  229 */       printDoctype();
/*      */       
/*      */       while (true) {
/*  232 */         this.scanner.clearBuffer();
/*  233 */         switch (this.type) {
/*      */           case 1:
/*  235 */             this.output.printTopSpaces(getCurrentValue());
/*  236 */             this.scanner.clearBuffer();
/*  237 */             this.type = this.scanner.next();
/*      */             continue;
/*      */           case 4:
/*  240 */             this.output.printComment(getCurrentValue());
/*  241 */             this.scanner.clearBuffer();
/*  242 */             this.type = this.scanner.next();
/*      */             continue;
/*      */           case 5:
/*  245 */             printPI();
/*      */             continue;
/*      */         } 
/*      */ 
/*      */         
/*      */         break;
/*      */       } 
/*  252 */       if (this.type != 9) {
/*  253 */         throw fatalError("element", null);
/*      */       }
/*      */       
/*  256 */       printElement();
/*      */       
/*      */       while (true) {
/*  259 */         switch (this.type) {
/*      */           case 1:
/*  261 */             this.output.printTopSpaces(getCurrentValue());
/*  262 */             this.scanner.clearBuffer();
/*  263 */             this.type = this.scanner.next();
/*      */             continue;
/*      */           case 4:
/*  266 */             this.output.printComment(getCurrentValue());
/*  267 */             this.scanner.clearBuffer();
/*  268 */             this.type = this.scanner.next();
/*      */             continue;
/*      */           case 5:
/*  271 */             printPI();
/*      */             continue;
/*      */         } 
/*      */         
/*      */         break;
/*      */       } 
/*      */     } catch (XMLException e) {
/*  278 */       this.errorHandler.fatalError(new TranscoderException(e.getMessage()));
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected void printXMLDecl() {
/*  289 */     if (this.xmlDeclaration == null) {
/*  290 */       if (this.type == 2) {
/*  291 */         if (this.scanner.next() != 1) {
/*  292 */           throw fatalError("space", null);
/*      */         }
/*  294 */         char[] space1 = getCurrentValue();
/*      */         
/*  296 */         if (this.scanner.next() != 22) {
/*  297 */           throw fatalError("token", new Object[] { "version" });
/*      */         }
/*  299 */         this.type = this.scanner.next();
/*      */         
/*  301 */         char[] space2 = null;
/*  302 */         if (this.type == 1) {
/*  303 */           space2 = getCurrentValue();
/*  304 */           this.type = this.scanner.next();
/*      */         } 
/*  306 */         if (this.type != 15) {
/*  307 */           throw fatalError("token", new Object[] { "=" });
/*      */         }
/*  309 */         this.type = this.scanner.next();
/*      */         
/*  311 */         char[] space3 = null;
/*  312 */         if (this.type == 1) {
/*  313 */           space3 = getCurrentValue();
/*  314 */           this.type = this.scanner.next();
/*      */         } 
/*      */         
/*  317 */         if (this.type != 25) {
/*  318 */           throw fatalError("string", null);
/*      */         }
/*      */         
/*  321 */         char[] version = getCurrentValue();
/*  322 */         char versionDelim = this.scanner.getStringDelimiter();
/*      */         
/*  324 */         char[] space4 = null;
/*  325 */         char[] space5 = null;
/*  326 */         char[] space6 = null;
/*  327 */         char[] encoding = null;
/*  328 */         char encodingDelim = Character.MIN_VALUE;
/*  329 */         char[] space7 = null;
/*  330 */         char[] space8 = null;
/*  331 */         char[] space9 = null;
/*  332 */         char[] standalone = null;
/*  333 */         char standaloneDelim = Character.MIN_VALUE;
/*  334 */         char[] space10 = null;
/*      */         
/*  336 */         this.type = this.scanner.next();
/*  337 */         if (this.type == 1) {
/*  338 */           space4 = getCurrentValue();
/*  339 */           this.type = this.scanner.next();
/*      */           
/*  341 */           if (this.type == 23) {
/*  342 */             this.type = this.scanner.next();
/*  343 */             if (this.type == 1) {
/*  344 */               space5 = getCurrentValue();
/*  345 */               this.type = this.scanner.next();
/*      */             } 
/*  347 */             if (this.type != 15) {
/*  348 */               throw fatalError("token", new Object[] { "=" });
/*      */             }
/*  350 */             this.type = this.scanner.next();
/*  351 */             if (this.type == 1) {
/*  352 */               space6 = getCurrentValue();
/*  353 */               this.type = this.scanner.next();
/*      */             } 
/*  355 */             if (this.type != 25) {
/*  356 */               throw fatalError("string", null);
/*      */             }
/*      */             
/*  359 */             encoding = getCurrentValue();
/*  360 */             encodingDelim = this.scanner.getStringDelimiter();
/*      */             
/*  362 */             this.type = this.scanner.next();
/*  363 */             if (this.type == 1) {
/*  364 */               space7 = getCurrentValue();
/*  365 */               this.type = this.scanner.next();
/*      */             } 
/*      */           } 
/*      */           
/*  369 */           if (this.type == 24) {
/*  370 */             this.type = this.scanner.next();
/*  371 */             if (this.type == 1) {
/*  372 */               space8 = getCurrentValue();
/*  373 */               this.type = this.scanner.next();
/*      */             } 
/*  375 */             if (this.type != 15) {
/*  376 */               throw fatalError("token", new Object[] { "=" });
/*      */             }
/*  378 */             this.type = this.scanner.next();
/*  379 */             if (this.type == 1) {
/*  380 */               space9 = getCurrentValue();
/*  381 */               this.type = this.scanner.next();
/*      */             } 
/*  383 */             if (this.type != 25) {
/*  384 */               throw fatalError("string", null);
/*      */             }
/*      */             
/*  387 */             standalone = getCurrentValue();
/*  388 */             standaloneDelim = this.scanner.getStringDelimiter();
/*      */             
/*  390 */             this.type = this.scanner.next();
/*  391 */             if (this.type == 1) {
/*  392 */               space10 = getCurrentValue();
/*  393 */               this.type = this.scanner.next();
/*      */             } 
/*      */           } 
/*      */         } 
/*  397 */         if (this.type != 7) {
/*  398 */           throw fatalError("pi.end", null);
/*      */         }
/*      */         
/*  401 */         this.output.printXMLDecl(space1, space2, space3, version, versionDelim, space4, space5, space6, encoding, encodingDelim, space7, space8, space9, standalone, standaloneDelim, space10);
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/*  409 */         this.type = this.scanner.next();
/*      */       } 
/*      */     } else {
/*  412 */       this.output.printString(this.xmlDeclaration);
/*  413 */       this.output.printNewline();
/*      */       
/*  415 */       if (this.type == 2) {
/*      */         
/*  417 */         if (this.scanner.next() != 1) {
/*  418 */           throw fatalError("space", null);
/*      */         }
/*      */         
/*  421 */         if (this.scanner.next() != 22) {
/*  422 */           throw fatalError("token", new Object[] { "version" });
/*      */         }
/*  424 */         this.type = this.scanner.next();
/*      */         
/*  426 */         if (this.type == 1) {
/*  427 */           this.type = this.scanner.next();
/*      */         }
/*  429 */         if (this.type != 15) {
/*  430 */           throw fatalError("token", new Object[] { "=" });
/*      */         }
/*  432 */         this.type = this.scanner.next();
/*      */         
/*  434 */         if (this.type == 1) {
/*  435 */           this.type = this.scanner.next();
/*      */         }
/*      */         
/*  438 */         if (this.type != 25) {
/*  439 */           throw fatalError("string", null);
/*      */         }
/*      */         
/*  442 */         this.type = this.scanner.next();
/*  443 */         if (this.type == 1) {
/*  444 */           this.type = this.scanner.next();
/*      */           
/*  446 */           if (this.type == 23) {
/*  447 */             this.type = this.scanner.next();
/*  448 */             if (this.type == 1) {
/*  449 */               this.type = this.scanner.next();
/*      */             }
/*  451 */             if (this.type != 15) {
/*  452 */               throw fatalError("token", new Object[] { "=" });
/*      */             }
/*  454 */             this.type = this.scanner.next();
/*  455 */             if (this.type == 1) {
/*  456 */               this.type = this.scanner.next();
/*      */             }
/*  458 */             if (this.type != 25) {
/*  459 */               throw fatalError("string", null);
/*      */             }
/*      */             
/*  462 */             this.type = this.scanner.next();
/*  463 */             if (this.type == 1) {
/*  464 */               this.type = this.scanner.next();
/*      */             }
/*      */           } 
/*      */           
/*  468 */           if (this.type == 24) {
/*  469 */             this.type = this.scanner.next();
/*  470 */             if (this.type == 1) {
/*  471 */               this.type = this.scanner.next();
/*      */             }
/*  473 */             if (this.type != 15) {
/*  474 */               throw fatalError("token", new Object[] { "=" });
/*      */             }
/*  476 */             this.type = this.scanner.next();
/*  477 */             if (this.type == 1) {
/*  478 */               this.type = this.scanner.next();
/*      */             }
/*  480 */             if (this.type != 25) {
/*  481 */               throw fatalError("string", null);
/*      */             }
/*      */             
/*  484 */             this.type = this.scanner.next();
/*  485 */             if (this.type == 1) {
/*  486 */               this.type = this.scanner.next();
/*      */             }
/*      */           } 
/*      */         } 
/*  490 */         if (this.type != 7) {
/*  491 */           throw fatalError("pi.end", null);
/*      */         }
/*      */         
/*  494 */         this.type = this.scanner.next();
/*      */       } 
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected void printPI() {
/*  506 */     char[] target = getCurrentValue();
/*      */     
/*  508 */     this.type = this.scanner.next();
/*  509 */     char[] space = new char[0];
/*  510 */     if (this.type == 1) {
/*  511 */       space = getCurrentValue();
/*  512 */       this.type = this.scanner.next();
/*      */     } 
/*  514 */     if (this.type != 6) {
/*  515 */       throw fatalError("pi.data", null);
/*      */     }
/*  517 */     char[] data = getCurrentValue();
/*      */     
/*  519 */     this.type = this.scanner.next();
/*  520 */     if (this.type != 7) {
/*  521 */       throw fatalError("pi.end", null);
/*      */     }
/*      */     
/*  524 */     this.output.printPI(target, space, data);
/*      */     
/*  526 */     this.type = this.scanner.next();
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected void printDoctype() { // Byte code:
/*      */     //   0: aload_0
/*      */     //   1: getfield doctypeOption : I
/*      */     //   4: lookupswitch default -> 24, 1 -> 1209
/*      */     //   24: aload_0
/*      */     //   25: getfield type : I
/*      */     //   28: iconst_3
/*      */     //   29: if_icmpne -> 1058
/*      */     //   32: aload_0
/*      */     //   33: aload_0
/*      */     //   34: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   37: invokevirtual next : ()I
/*      */     //   40: putfield type : I
/*      */     //   43: aload_0
/*      */     //   44: getfield type : I
/*      */     //   47: iconst_1
/*      */     //   48: if_icmpeq -> 59
/*      */     //   51: aload_0
/*      */     //   52: ldc 'space'
/*      */     //   54: aconst_null
/*      */     //   55: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   58: athrow
/*      */     //   59: aload_0
/*      */     //   60: invokevirtual getCurrentValue : ()[C
/*      */     //   63: astore_1
/*      */     //   64: aload_0
/*      */     //   65: aload_0
/*      */     //   66: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   69: invokevirtual next : ()I
/*      */     //   72: putfield type : I
/*      */     //   75: aload_0
/*      */     //   76: getfield type : I
/*      */     //   79: bipush #14
/*      */     //   81: if_icmpeq -> 92
/*      */     //   84: aload_0
/*      */     //   85: ldc 'name'
/*      */     //   87: aconst_null
/*      */     //   88: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   91: athrow
/*      */     //   92: aload_0
/*      */     //   93: invokevirtual getCurrentValue : ()[C
/*      */     //   96: astore_2
/*      */     //   97: aconst_null
/*      */     //   98: astore_3
/*      */     //   99: aconst_null
/*      */     //   100: astore #4
/*      */     //   102: aconst_null
/*      */     //   103: astore #5
/*      */     //   105: aconst_null
/*      */     //   106: astore #6
/*      */     //   108: iconst_0
/*      */     //   109: istore #7
/*      */     //   111: aconst_null
/*      */     //   112: astore #8
/*      */     //   114: aconst_null
/*      */     //   115: astore #9
/*      */     //   117: iconst_0
/*      */     //   118: istore #10
/*      */     //   120: aconst_null
/*      */     //   121: astore #11
/*      */     //   123: aload_0
/*      */     //   124: aload_0
/*      */     //   125: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   128: invokevirtual next : ()I
/*      */     //   131: putfield type : I
/*      */     //   134: aload_0
/*      */     //   135: getfield type : I
/*      */     //   138: iconst_1
/*      */     //   139: if_icmpne -> 499
/*      */     //   142: aload_0
/*      */     //   143: invokevirtual getCurrentValue : ()[C
/*      */     //   146: astore_3
/*      */     //   147: aload_0
/*      */     //   148: aload_0
/*      */     //   149: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   152: invokevirtual next : ()I
/*      */     //   155: putfield type : I
/*      */     //   158: aload_0
/*      */     //   159: getfield type : I
/*      */     //   162: lookupswitch default -> 499, 26 -> 383, 27 -> 188
/*      */     //   188: ldc 'PUBLIC'
/*      */     //   190: astore #4
/*      */     //   192: aload_0
/*      */     //   193: aload_0
/*      */     //   194: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   197: invokevirtual next : ()I
/*      */     //   200: putfield type : I
/*      */     //   203: aload_0
/*      */     //   204: getfield type : I
/*      */     //   207: iconst_1
/*      */     //   208: if_icmpeq -> 219
/*      */     //   211: aload_0
/*      */     //   212: ldc 'space'
/*      */     //   214: aconst_null
/*      */     //   215: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   218: athrow
/*      */     //   219: aload_0
/*      */     //   220: invokevirtual getCurrentValue : ()[C
/*      */     //   223: astore #5
/*      */     //   225: aload_0
/*      */     //   226: aload_0
/*      */     //   227: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   230: invokevirtual next : ()I
/*      */     //   233: putfield type : I
/*      */     //   236: aload_0
/*      */     //   237: getfield type : I
/*      */     //   240: bipush #25
/*      */     //   242: if_icmpeq -> 253
/*      */     //   245: aload_0
/*      */     //   246: ldc 'string'
/*      */     //   248: aconst_null
/*      */     //   249: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   252: athrow
/*      */     //   253: aload_0
/*      */     //   254: invokevirtual getCurrentValue : ()[C
/*      */     //   257: astore #6
/*      */     //   259: aload_0
/*      */     //   260: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   263: invokevirtual getStringDelimiter : ()C
/*      */     //   266: istore #7
/*      */     //   268: aload_0
/*      */     //   269: aload_0
/*      */     //   270: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   273: invokevirtual next : ()I
/*      */     //   276: putfield type : I
/*      */     //   279: aload_0
/*      */     //   280: getfield type : I
/*      */     //   283: iconst_1
/*      */     //   284: if_icmpeq -> 295
/*      */     //   287: aload_0
/*      */     //   288: ldc 'space'
/*      */     //   290: aconst_null
/*      */     //   291: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   294: athrow
/*      */     //   295: aload_0
/*      */     //   296: invokevirtual getCurrentValue : ()[C
/*      */     //   299: astore #8
/*      */     //   301: aload_0
/*      */     //   302: aload_0
/*      */     //   303: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   306: invokevirtual next : ()I
/*      */     //   309: putfield type : I
/*      */     //   312: aload_0
/*      */     //   313: getfield type : I
/*      */     //   316: bipush #25
/*      */     //   318: if_icmpeq -> 329
/*      */     //   321: aload_0
/*      */     //   322: ldc 'string'
/*      */     //   324: aconst_null
/*      */     //   325: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   328: athrow
/*      */     //   329: aload_0
/*      */     //   330: invokevirtual getCurrentValue : ()[C
/*      */     //   333: astore #9
/*      */     //   335: aload_0
/*      */     //   336: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   339: invokevirtual getStringDelimiter : ()C
/*      */     //   342: istore #10
/*      */     //   344: aload_0
/*      */     //   345: aload_0
/*      */     //   346: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   349: invokevirtual next : ()I
/*      */     //   352: putfield type : I
/*      */     //   355: aload_0
/*      */     //   356: getfield type : I
/*      */     //   359: iconst_1
/*      */     //   360: if_icmpne -> 499
/*      */     //   363: aload_0
/*      */     //   364: invokevirtual getCurrentValue : ()[C
/*      */     //   367: astore #11
/*      */     //   369: aload_0
/*      */     //   370: aload_0
/*      */     //   371: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   374: invokevirtual next : ()I
/*      */     //   377: putfield type : I
/*      */     //   380: goto -> 499
/*      */     //   383: ldc 'SYSTEM'
/*      */     //   385: astore #4
/*      */     //   387: aload_0
/*      */     //   388: aload_0
/*      */     //   389: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   392: invokevirtual next : ()I
/*      */     //   395: putfield type : I
/*      */     //   398: aload_0
/*      */     //   399: getfield type : I
/*      */     //   402: iconst_1
/*      */     //   403: if_icmpeq -> 414
/*      */     //   406: aload_0
/*      */     //   407: ldc 'space'
/*      */     //   409: aconst_null
/*      */     //   410: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   413: athrow
/*      */     //   414: aload_0
/*      */     //   415: invokevirtual getCurrentValue : ()[C
/*      */     //   418: astore #5
/*      */     //   420: aload_0
/*      */     //   421: aload_0
/*      */     //   422: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   425: invokevirtual next : ()I
/*      */     //   428: putfield type : I
/*      */     //   431: aload_0
/*      */     //   432: getfield type : I
/*      */     //   435: bipush #25
/*      */     //   437: if_icmpeq -> 448
/*      */     //   440: aload_0
/*      */     //   441: ldc 'string'
/*      */     //   443: aconst_null
/*      */     //   444: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   447: athrow
/*      */     //   448: aload_0
/*      */     //   449: invokevirtual getCurrentValue : ()[C
/*      */     //   452: astore #6
/*      */     //   454: aload_0
/*      */     //   455: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   458: invokevirtual getStringDelimiter : ()C
/*      */     //   461: istore #7
/*      */     //   463: aload_0
/*      */     //   464: aload_0
/*      */     //   465: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   468: invokevirtual next : ()I
/*      */     //   471: putfield type : I
/*      */     //   474: aload_0
/*      */     //   475: getfield type : I
/*      */     //   478: iconst_1
/*      */     //   479: if_icmpne -> 499
/*      */     //   482: aload_0
/*      */     //   483: invokevirtual getCurrentValue : ()[C
/*      */     //   486: astore #8
/*      */     //   488: aload_0
/*      */     //   489: aload_0
/*      */     //   490: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   493: invokevirtual next : ()I
/*      */     //   496: putfield type : I
/*      */     //   499: aload_0
/*      */     //   500: getfield doctypeOption : I
/*      */     //   503: ifne -> 580
/*      */     //   506: aload_0
/*      */     //   507: getfield publicId : Ljava/lang/String;
/*      */     //   510: ifnull -> 553
/*      */     //   513: ldc 'PUBLIC'
/*      */     //   515: astore #4
/*      */     //   517: aload_0
/*      */     //   518: getfield publicId : Ljava/lang/String;
/*      */     //   521: invokevirtual toCharArray : ()[C
/*      */     //   524: astore #6
/*      */     //   526: bipush #34
/*      */     //   528: istore #7
/*      */     //   530: aload_0
/*      */     //   531: getfield systemId : Ljava/lang/String;
/*      */     //   534: ifnull -> 580
/*      */     //   537: aload_0
/*      */     //   538: getfield systemId : Ljava/lang/String;
/*      */     //   541: invokevirtual toCharArray : ()[C
/*      */     //   544: astore #9
/*      */     //   546: bipush #34
/*      */     //   548: istore #10
/*      */     //   550: goto -> 580
/*      */     //   553: aload_0
/*      */     //   554: getfield systemId : Ljava/lang/String;
/*      */     //   557: ifnull -> 580
/*      */     //   560: ldc 'SYSTEM'
/*      */     //   562: astore #4
/*      */     //   564: aload_0
/*      */     //   565: getfield systemId : Ljava/lang/String;
/*      */     //   568: invokevirtual toCharArray : ()[C
/*      */     //   571: astore #6
/*      */     //   573: bipush #34
/*      */     //   575: istore #7
/*      */     //   577: aconst_null
/*      */     //   578: astore #9
/*      */     //   580: aload_0
/*      */     //   581: getfield output : Lorg/apache/batik/transcoder/svg2svg/OutputManager;
/*      */     //   584: aload_1
/*      */     //   585: aload_2
/*      */     //   586: aload_3
/*      */     //   587: aload #4
/*      */     //   589: aload #5
/*      */     //   591: aload #6
/*      */     //   593: iload #7
/*      */     //   595: aload #8
/*      */     //   597: aload #9
/*      */     //   599: iload #10
/*      */     //   601: aload #11
/*      */     //   603: invokevirtual printDoctypeStart : ([C[C[CLjava/lang/String;[C[CC[C[CC[C)V
/*      */     //   606: aload_0
/*      */     //   607: getfield type : I
/*      */     //   610: bipush #28
/*      */     //   612: if_icmpne -> 990
/*      */     //   615: aload_0
/*      */     //   616: getfield output : Lorg/apache/batik/transcoder/svg2svg/OutputManager;
/*      */     //   619: bipush #91
/*      */     //   621: invokevirtual printCharacter : (C)V
/*      */     //   624: aload_0
/*      */     //   625: aload_0
/*      */     //   626: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   629: invokevirtual next : ()I
/*      */     //   632: putfield type : I
/*      */     //   635: goto -> 638
/*      */     //   638: aload_0
/*      */     //   639: getfield type : I
/*      */     //   642: tableswitch default -> 982, 1 -> 792, 2 -> 982, 3 -> 982, 4 -> 825, 5 -> 857, 6 -> 982, 7 -> 982, 8 -> 982, 9 -> 982, 10 -> 982, 11 -> 982, 12 -> 982, 13 -> 982, 14 -> 982, 15 -> 982, 16 -> 982, 17 -> 982, 18 -> 982, 19 -> 982, 20 -> 982, 21 -> 982, 22 -> 982, 23 -> 982, 24 -> 982, 25 -> 982, 26 -> 982, 27 -> 982, 28 -> 982, 29 -> 952, 30 -> 896, 31 -> 910, 32 -> 938, 33 -> 924, 34 -> 864
/*      */     //   792: aload_0
/*      */     //   793: getfield output : Lorg/apache/batik/transcoder/svg2svg/OutputManager;
/*      */     //   796: aload_0
/*      */     //   797: invokevirtual getCurrentValue : ()[C
/*      */     //   800: iconst_1
/*      */     //   801: invokevirtual printSpaces : ([CZ)V
/*      */     //   804: aload_0
/*      */     //   805: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   808: invokevirtual clearBuffer : ()V
/*      */     //   811: aload_0
/*      */     //   812: aload_0
/*      */     //   813: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   816: invokevirtual next : ()I
/*      */     //   819: putfield type : I
/*      */     //   822: goto -> 638
/*      */     //   825: aload_0
/*      */     //   826: getfield output : Lorg/apache/batik/transcoder/svg2svg/OutputManager;
/*      */     //   829: aload_0
/*      */     //   830: invokevirtual getCurrentValue : ()[C
/*      */     //   833: invokevirtual printComment : ([C)V
/*      */     //   836: aload_0
/*      */     //   837: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   840: invokevirtual clearBuffer : ()V
/*      */     //   843: aload_0
/*      */     //   844: aload_0
/*      */     //   845: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   848: invokevirtual next : ()I
/*      */     //   851: putfield type : I
/*      */     //   854: goto -> 638
/*      */     //   857: aload_0
/*      */     //   858: invokevirtual printPI : ()V
/*      */     //   861: goto -> 638
/*      */     //   864: aload_0
/*      */     //   865: getfield output : Lorg/apache/batik/transcoder/svg2svg/OutputManager;
/*      */     //   868: aload_0
/*      */     //   869: invokevirtual getCurrentValue : ()[C
/*      */     //   872: invokevirtual printParameterEntityReference : ([C)V
/*      */     //   875: aload_0
/*      */     //   876: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   879: invokevirtual clearBuffer : ()V
/*      */     //   882: aload_0
/*      */     //   883: aload_0
/*      */     //   884: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   887: invokevirtual next : ()I
/*      */     //   890: putfield type : I
/*      */     //   893: goto -> 638
/*      */     //   896: aload_0
/*      */     //   897: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   900: invokevirtual clearBuffer : ()V
/*      */     //   903: aload_0
/*      */     //   904: invokevirtual printElementDeclaration : ()V
/*      */     //   907: goto -> 638
/*      */     //   910: aload_0
/*      */     //   911: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   914: invokevirtual clearBuffer : ()V
/*      */     //   917: aload_0
/*      */     //   918: invokevirtual printAttlist : ()V
/*      */     //   921: goto -> 638
/*      */     //   924: aload_0
/*      */     //   925: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   928: invokevirtual clearBuffer : ()V
/*      */     //   931: aload_0
/*      */     //   932: invokevirtual printNotation : ()V
/*      */     //   935: goto -> 638
/*      */     //   938: aload_0
/*      */     //   939: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   942: invokevirtual clearBuffer : ()V
/*      */     //   945: aload_0
/*      */     //   946: invokevirtual printEntityDeclaration : ()V
/*      */     //   949: goto -> 638
/*      */     //   952: aload_0
/*      */     //   953: getfield output : Lorg/apache/batik/transcoder/svg2svg/OutputManager;
/*      */     //   956: bipush #93
/*      */     //   958: invokevirtual printCharacter : (C)V
/*      */     //   961: aload_0
/*      */     //   962: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   965: invokevirtual clearBuffer : ()V
/*      */     //   968: aload_0
/*      */     //   969: aload_0
/*      */     //   970: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   973: invokevirtual next : ()I
/*      */     //   976: putfield type : I
/*      */     //   979: goto -> 990
/*      */     //   982: aload_0
/*      */     //   983: ldc 'xml'
/*      */     //   985: aconst_null
/*      */     //   986: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   989: athrow
/*      */     //   990: aconst_null
/*      */     //   991: astore #12
/*      */     //   993: aload_0
/*      */     //   994: getfield type : I
/*      */     //   997: iconst_1
/*      */     //   998: if_icmpne -> 1018
/*      */     //   1001: aload_0
/*      */     //   1002: invokevirtual getCurrentValue : ()[C
/*      */     //   1005: astore #12
/*      */     //   1007: aload_0
/*      */     //   1008: aload_0
/*      */     //   1009: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1012: invokevirtual next : ()I
/*      */     //   1015: putfield type : I
/*      */     //   1018: aload_0
/*      */     //   1019: getfield type : I
/*      */     //   1022: bipush #20
/*      */     //   1024: if_icmpeq -> 1035
/*      */     //   1027: aload_0
/*      */     //   1028: ldc 'end'
/*      */     //   1030: aconst_null
/*      */     //   1031: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1034: athrow
/*      */     //   1035: aload_0
/*      */     //   1036: aload_0
/*      */     //   1037: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1040: invokevirtual next : ()I
/*      */     //   1043: putfield type : I
/*      */     //   1046: aload_0
/*      */     //   1047: getfield output : Lorg/apache/batik/transcoder/svg2svg/OutputManager;
/*      */     //   1050: aload #12
/*      */     //   1052: invokevirtual printDoctypeEnd : ([C)V
/*      */     //   1055: goto -> 1636
/*      */     //   1058: aload_0
/*      */     //   1059: getfield doctypeOption : I
/*      */     //   1062: ifne -> 1636
/*      */     //   1065: ldc 'PUBLIC'
/*      */     //   1067: astore_1
/*      */     //   1068: ldc '-//W3C//DTD SVG 1.0//EN'
/*      */     //   1070: invokevirtual toCharArray : ()[C
/*      */     //   1073: astore_2
/*      */     //   1074: ldc 'http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd'
/*      */     //   1076: invokevirtual toCharArray : ()[C
/*      */     //   1079: astore_3
/*      */     //   1080: aload_0
/*      */     //   1081: getfield publicId : Ljava/lang/String;
/*      */     //   1084: ifnull -> 1113
/*      */     //   1087: aload_0
/*      */     //   1088: getfield publicId : Ljava/lang/String;
/*      */     //   1091: invokevirtual toCharArray : ()[C
/*      */     //   1094: astore_2
/*      */     //   1095: aload_0
/*      */     //   1096: getfield systemId : Ljava/lang/String;
/*      */     //   1099: ifnull -> 1133
/*      */     //   1102: aload_0
/*      */     //   1103: getfield systemId : Ljava/lang/String;
/*      */     //   1106: invokevirtual toCharArray : ()[C
/*      */     //   1109: astore_3
/*      */     //   1110: goto -> 1133
/*      */     //   1113: aload_0
/*      */     //   1114: getfield systemId : Ljava/lang/String;
/*      */     //   1117: ifnull -> 1133
/*      */     //   1120: ldc 'SYSTEM'
/*      */     //   1122: astore_1
/*      */     //   1123: aload_0
/*      */     //   1124: getfield systemId : Ljava/lang/String;
/*      */     //   1127: invokevirtual toCharArray : ()[C
/*      */     //   1130: astore_2
/*      */     //   1131: aconst_null
/*      */     //   1132: astore_3
/*      */     //   1133: aload_0
/*      */     //   1134: getfield output : Lorg/apache/batik/transcoder/svg2svg/OutputManager;
/*      */     //   1137: iconst_1
/*      */     //   1138: newarray char
/*      */     //   1140: dup
/*      */     //   1141: iconst_0
/*      */     //   1142: bipush #32
/*      */     //   1144: castore
/*      */     //   1145: iconst_3
/*      */     //   1146: newarray char
/*      */     //   1148: dup
/*      */     //   1149: iconst_0
/*      */     //   1150: bipush #115
/*      */     //   1152: castore
/*      */     //   1153: dup
/*      */     //   1154: iconst_1
/*      */     //   1155: bipush #118
/*      */     //   1157: castore
/*      */     //   1158: dup
/*      */     //   1159: iconst_2
/*      */     //   1160: bipush #103
/*      */     //   1162: castore
/*      */     //   1163: iconst_1
/*      */     //   1164: newarray char
/*      */     //   1166: dup
/*      */     //   1167: iconst_0
/*      */     //   1168: bipush #32
/*      */     //   1170: castore
/*      */     //   1171: aload_1
/*      */     //   1172: iconst_1
/*      */     //   1173: newarray char
/*      */     //   1175: dup
/*      */     //   1176: iconst_0
/*      */     //   1177: bipush #32
/*      */     //   1179: castore
/*      */     //   1180: aload_2
/*      */     //   1181: bipush #34
/*      */     //   1183: iconst_1
/*      */     //   1184: newarray char
/*      */     //   1186: dup
/*      */     //   1187: iconst_0
/*      */     //   1188: bipush #32
/*      */     //   1190: castore
/*      */     //   1191: aload_3
/*      */     //   1192: bipush #34
/*      */     //   1194: aconst_null
/*      */     //   1195: invokevirtual printDoctypeStart : ([C[C[CLjava/lang/String;[C[CC[C[CC[C)V
/*      */     //   1198: aload_0
/*      */     //   1199: getfield output : Lorg/apache/batik/transcoder/svg2svg/OutputManager;
/*      */     //   1202: aconst_null
/*      */     //   1203: invokevirtual printDoctypeEnd : ([C)V
/*      */     //   1206: goto -> 1636
/*      */     //   1209: aload_0
/*      */     //   1210: getfield type : I
/*      */     //   1213: iconst_3
/*      */     //   1214: if_icmpne -> 1625
/*      */     //   1217: aload_0
/*      */     //   1218: aload_0
/*      */     //   1219: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1222: invokevirtual next : ()I
/*      */     //   1225: putfield type : I
/*      */     //   1228: aload_0
/*      */     //   1229: getfield type : I
/*      */     //   1232: iconst_1
/*      */     //   1233: if_icmpeq -> 1244
/*      */     //   1236: aload_0
/*      */     //   1237: ldc 'space'
/*      */     //   1239: aconst_null
/*      */     //   1240: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1243: athrow
/*      */     //   1244: aload_0
/*      */     //   1245: aload_0
/*      */     //   1246: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1249: invokevirtual next : ()I
/*      */     //   1252: putfield type : I
/*      */     //   1255: aload_0
/*      */     //   1256: getfield type : I
/*      */     //   1259: bipush #14
/*      */     //   1261: if_icmpeq -> 1272
/*      */     //   1264: aload_0
/*      */     //   1265: ldc 'name'
/*      */     //   1267: aconst_null
/*      */     //   1268: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1271: athrow
/*      */     //   1272: aload_0
/*      */     //   1273: aload_0
/*      */     //   1274: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1277: invokevirtual next : ()I
/*      */     //   1280: putfield type : I
/*      */     //   1283: aload_0
/*      */     //   1284: getfield type : I
/*      */     //   1287: iconst_1
/*      */     //   1288: if_icmpne -> 1560
/*      */     //   1291: aload_0
/*      */     //   1292: aload_0
/*      */     //   1293: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1296: invokevirtual next : ()I
/*      */     //   1299: putfield type : I
/*      */     //   1302: aload_0
/*      */     //   1303: getfield type : I
/*      */     //   1306: lookupswitch default -> 1560, 26 -> 1475, 27 -> 1332
/*      */     //   1332: aload_0
/*      */     //   1333: aload_0
/*      */     //   1334: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1337: invokevirtual next : ()I
/*      */     //   1340: putfield type : I
/*      */     //   1343: aload_0
/*      */     //   1344: getfield type : I
/*      */     //   1347: iconst_1
/*      */     //   1348: if_icmpeq -> 1359
/*      */     //   1351: aload_0
/*      */     //   1352: ldc 'space'
/*      */     //   1354: aconst_null
/*      */     //   1355: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1358: athrow
/*      */     //   1359: aload_0
/*      */     //   1360: aload_0
/*      */     //   1361: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1364: invokevirtual next : ()I
/*      */     //   1367: putfield type : I
/*      */     //   1370: aload_0
/*      */     //   1371: getfield type : I
/*      */     //   1374: bipush #25
/*      */     //   1376: if_icmpeq -> 1387
/*      */     //   1379: aload_0
/*      */     //   1380: ldc 'string'
/*      */     //   1382: aconst_null
/*      */     //   1383: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1386: athrow
/*      */     //   1387: aload_0
/*      */     //   1388: aload_0
/*      */     //   1389: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1392: invokevirtual next : ()I
/*      */     //   1395: putfield type : I
/*      */     //   1398: aload_0
/*      */     //   1399: getfield type : I
/*      */     //   1402: iconst_1
/*      */     //   1403: if_icmpeq -> 1414
/*      */     //   1406: aload_0
/*      */     //   1407: ldc 'space'
/*      */     //   1409: aconst_null
/*      */     //   1410: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1413: athrow
/*      */     //   1414: aload_0
/*      */     //   1415: aload_0
/*      */     //   1416: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1419: invokevirtual next : ()I
/*      */     //   1422: putfield type : I
/*      */     //   1425: aload_0
/*      */     //   1426: getfield type : I
/*      */     //   1429: bipush #25
/*      */     //   1431: if_icmpeq -> 1442
/*      */     //   1434: aload_0
/*      */     //   1435: ldc 'string'
/*      */     //   1437: aconst_null
/*      */     //   1438: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1441: athrow
/*      */     //   1442: aload_0
/*      */     //   1443: aload_0
/*      */     //   1444: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1447: invokevirtual next : ()I
/*      */     //   1450: putfield type : I
/*      */     //   1453: aload_0
/*      */     //   1454: getfield type : I
/*      */     //   1457: iconst_1
/*      */     //   1458: if_icmpne -> 1560
/*      */     //   1461: aload_0
/*      */     //   1462: aload_0
/*      */     //   1463: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1466: invokevirtual next : ()I
/*      */     //   1469: putfield type : I
/*      */     //   1472: goto -> 1560
/*      */     //   1475: aload_0
/*      */     //   1476: aload_0
/*      */     //   1477: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1480: invokevirtual next : ()I
/*      */     //   1483: putfield type : I
/*      */     //   1486: aload_0
/*      */     //   1487: getfield type : I
/*      */     //   1490: iconst_1
/*      */     //   1491: if_icmpeq -> 1502
/*      */     //   1494: aload_0
/*      */     //   1495: ldc 'space'
/*      */     //   1497: aconst_null
/*      */     //   1498: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1501: athrow
/*      */     //   1502: aload_0
/*      */     //   1503: aload_0
/*      */     //   1504: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1507: invokevirtual next : ()I
/*      */     //   1510: putfield type : I
/*      */     //   1513: aload_0
/*      */     //   1514: getfield type : I
/*      */     //   1517: bipush #25
/*      */     //   1519: if_icmpeq -> 1530
/*      */     //   1522: aload_0
/*      */     //   1523: ldc 'string'
/*      */     //   1525: aconst_null
/*      */     //   1526: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1529: athrow
/*      */     //   1530: aload_0
/*      */     //   1531: aload_0
/*      */     //   1532: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1535: invokevirtual next : ()I
/*      */     //   1538: putfield type : I
/*      */     //   1541: aload_0
/*      */     //   1542: getfield type : I
/*      */     //   1545: iconst_1
/*      */     //   1546: if_icmpne -> 1560
/*      */     //   1549: aload_0
/*      */     //   1550: aload_0
/*      */     //   1551: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1554: invokevirtual next : ()I
/*      */     //   1557: putfield type : I
/*      */     //   1560: aload_0
/*      */     //   1561: getfield type : I
/*      */     //   1564: bipush #28
/*      */     //   1566: if_icmpne -> 1589
/*      */     //   1569: aload_0
/*      */     //   1570: aload_0
/*      */     //   1571: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1574: invokevirtual next : ()I
/*      */     //   1577: putfield type : I
/*      */     //   1580: aload_0
/*      */     //   1581: getfield type : I
/*      */     //   1584: bipush #29
/*      */     //   1586: if_icmpne -> 1569
/*      */     //   1589: aload_0
/*      */     //   1590: getfield type : I
/*      */     //   1593: iconst_1
/*      */     //   1594: if_icmpne -> 1608
/*      */     //   1597: aload_0
/*      */     //   1598: aload_0
/*      */     //   1599: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1602: invokevirtual next : ()I
/*      */     //   1605: putfield type : I
/*      */     //   1608: aload_0
/*      */     //   1609: getfield type : I
/*      */     //   1612: bipush #20
/*      */     //   1614: if_icmpeq -> 1625
/*      */     //   1617: aload_0
/*      */     //   1618: ldc 'end'
/*      */     //   1620: aconst_null
/*      */     //   1621: invokevirtual fatalError : (Ljava/lang/String;[Ljava/lang/Object;)Lorg/apache/batik/transcoder/TranscoderException;
/*      */     //   1624: athrow
/*      */     //   1625: aload_0
/*      */     //   1626: aload_0
/*      */     //   1627: getfield scanner : Lorg/apache/batik/xml/XMLScanner;
/*      */     //   1630: invokevirtual next : ()I
/*      */     //   1633: putfield type : I
/*      */     //   1636: return
/*      */     // Line number table:
/*      */     //   Java source line number -> byte code offset
/*      */     //   #536	-> 0
/*      */     //   #538	-> 24
/*      */     //   #539	-> 32
/*      */     //   #541	-> 43
/*      */     //   #542	-> 51
/*      */     //   #544	-> 59
/*      */     //   #545	-> 64
/*      */     //   #547	-> 75
/*      */     //   #548	-> 84
/*      */     //   #551	-> 92
/*      */     //   #552	-> 97
/*      */     //   #553	-> 99
/*      */     //   #554	-> 102
/*      */     //   #555	-> 105
/*      */     //   #556	-> 108
/*      */     //   #557	-> 111
/*      */     //   #558	-> 114
/*      */     //   #559	-> 117
/*      */     //   #560	-> 120
/*      */     //   #562	-> 123
/*      */     //   #563	-> 134
/*      */     //   #564	-> 142
/*      */     //   #565	-> 147
/*      */     //   #567	-> 158
/*      */     //   #569	-> 188
/*      */     //   #571	-> 192
/*      */     //   #572	-> 203
/*      */     //   #573	-> 211
/*      */     //   #575	-> 219
/*      */     //   #576	-> 225
/*      */     //   #578	-> 236
/*      */     //   #579	-> 245
/*      */     //   #582	-> 253
/*      */     //   #583	-> 259
/*      */     //   #585	-> 268
/*      */     //   #586	-> 279
/*      */     //   #587	-> 287
/*      */     //   #589	-> 295
/*      */     //   #590	-> 301
/*      */     //   #592	-> 312
/*      */     //   #593	-> 321
/*      */     //   #596	-> 329
/*      */     //   #597	-> 335
/*      */     //   #599	-> 344
/*      */     //   #600	-> 355
/*      */     //   #601	-> 363
/*      */     //   #602	-> 369
/*      */     //   #606	-> 383
/*      */     //   #608	-> 387
/*      */     //   #609	-> 398
/*      */     //   #610	-> 406
/*      */     //   #612	-> 414
/*      */     //   #613	-> 420
/*      */     //   #615	-> 431
/*      */     //   #616	-> 440
/*      */     //   #619	-> 448
/*      */     //   #620	-> 454
/*      */     //   #622	-> 463
/*      */     //   #623	-> 474
/*      */     //   #624	-> 482
/*      */     //   #625	-> 488
/*      */     //   #630	-> 499
/*      */     //   #631	-> 506
/*      */     //   #632	-> 513
/*      */     //   #633	-> 517
/*      */     //   #634	-> 526
/*      */     //   #635	-> 530
/*      */     //   #636	-> 537
/*      */     //   #637	-> 546
/*      */     //   #639	-> 553
/*      */     //   #640	-> 560
/*      */     //   #641	-> 564
/*      */     //   #642	-> 573
/*      */     //   #643	-> 577
/*      */     //   #646	-> 580
/*      */     //   #653	-> 606
/*      */     //   #654	-> 615
/*      */     //   #655	-> 624
/*      */     //   #657	-> 635
/*      */     //   #658	-> 638
/*      */     //   #660	-> 792
/*      */     //   #661	-> 804
/*      */     //   #662	-> 811
/*      */     //   #663	-> 822
/*      */     //   #665	-> 825
/*      */     //   #666	-> 836
/*      */     //   #667	-> 843
/*      */     //   #668	-> 854
/*      */     //   #670	-> 857
/*      */     //   #671	-> 861
/*      */     //   #673	-> 864
/*      */     //   #674	-> 875
/*      */     //   #675	-> 882
/*      */     //   #676	-> 893
/*      */     //   #678	-> 896
/*      */     //   #679	-> 903
/*      */     //   #680	-> 907
/*      */     //   #682	-> 910
/*      */     //   #683	-> 917
/*      */     //   #684	-> 921
/*      */     //   #686	-> 924
/*      */     //   #687	-> 931
/*      */     //   #688	-> 935
/*      */     //   #690	-> 938
/*      */     //   #691	-> 945
/*      */     //   #692	-> 949
/*      */     //   #694	-> 952
/*      */     //   #695	-> 961
/*      */     //   #696	-> 968
/*      */     //   #697	-> 979
/*      */     //   #699	-> 982
/*      */     //   #703	-> 990
/*      */     //   #704	-> 993
/*      */     //   #705	-> 1001
/*      */     //   #706	-> 1007
/*      */     //   #709	-> 1018
/*      */     //   #710	-> 1027
/*      */     //   #712	-> 1035
/*      */     //   #713	-> 1046
/*      */     //   #715	-> 1058
/*      */     //   #716	-> 1065
/*      */     //   #717	-> 1068
/*      */     //   #718	-> 1074
/*      */     //   #719	-> 1080
/*      */     //   #720	-> 1087
/*      */     //   #721	-> 1095
/*      */     //   #722	-> 1102
/*      */     //   #724	-> 1113
/*      */     //   #725	-> 1120
/*      */     //   #726	-> 1123
/*      */     //   #727	-> 1131
/*      */     //   #729	-> 1133
/*      */     //   #738	-> 1198
/*      */     //   #745	-> 1209
/*      */     //   #746	-> 1217
/*      */     //   #748	-> 1228
/*      */     //   #749	-> 1236
/*      */     //   #751	-> 1244
/*      */     //   #753	-> 1255
/*      */     //   #754	-> 1264
/*      */     //   #757	-> 1272
/*      */     //   #758	-> 1283
/*      */     //   #759	-> 1291
/*      */     //   #761	-> 1302
/*      */     //   #764	-> 1332
/*      */     //   #765	-> 1343
/*      */     //   #766	-> 1351
/*      */     //   #768	-> 1359
/*      */     //   #770	-> 1370
/*      */     //   #771	-> 1379
/*      */     //   #774	-> 1387
/*      */     //   #775	-> 1398
/*      */     //   #776	-> 1406
/*      */     //   #778	-> 1414
/*      */     //   #780	-> 1425
/*      */     //   #781	-> 1434
/*      */     //   #784	-> 1442
/*      */     //   #785	-> 1453
/*      */     //   #786	-> 1461
/*      */     //   #791	-> 1475
/*      */     //   #792	-> 1486
/*      */     //   #793	-> 1494
/*      */     //   #795	-> 1502
/*      */     //   #797	-> 1513
/*      */     //   #798	-> 1522
/*      */     //   #801	-> 1530
/*      */     //   #802	-> 1541
/*      */     //   #803	-> 1549
/*      */     //   #808	-> 1560
/*      */     //   #810	-> 1569
/*      */     //   #811	-> 1580
/*      */     //   #813	-> 1589
/*      */     //   #814	-> 1597
/*      */     //   #817	-> 1608
/*      */     //   #818	-> 1617
/*      */     //   #821	-> 1625
/*      */     //   #823	-> 1636
/*      */     // Local variable table:
/*      */     //   start	length	slot	name	descriptor
/*      */     //   0	1637	0	this	Lorg/apache/batik/transcoder/svg2svg/PrettyPrinter;
/*      */     //   64	991	1	space1	[C
/*      */     //   97	958	2	root	[C
/*      */     //   99	956	3	space2	[C
/*      */     //   102	953	4	externalId	Ljava/lang/String;
/*      */     //   105	950	5	space3	[C
/*      */     //   108	947	6	string1	[C
/*      */     //   111	944	7	string1Delim	C
/*      */     //   114	941	8	space4	[C
/*      */     //   117	938	9	string2	[C
/*      */     //   120	935	10	string2Delim	C
/*      */     //   123	932	11	space5	[C
/*      */     //   993	62	12	endSpace	[C
/*      */     //   1068	138	1	externalId	Ljava/lang/String;
/*      */     //   1074	132	2	string1	[C
/*      */     //   1080	126	3	string2	[C }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected String printElement() {
/*  832 */     char[] name = getCurrentValue();
/*  833 */     String nameStr = new String(name);
/*  834 */     List attributes = new LinkedList();
/*  835 */     char[] space = null;
/*      */     
/*  837 */     this.type = this.scanner.next();
/*  838 */     while (this.type == 1) {
/*  839 */       space = getCurrentValue();
/*      */       
/*  841 */       this.type = this.scanner.next();
/*  842 */       if (this.type == 14) {
/*  843 */         char[] attName = getCurrentValue();
/*  844 */         char[] space1 = null;
/*      */         
/*  846 */         this.type = this.scanner.next();
/*  847 */         if (this.type == 1) {
/*  848 */           space1 = getCurrentValue();
/*  849 */           this.type = this.scanner.next();
/*      */         } 
/*  851 */         if (this.type != 15) {
/*  852 */           throw fatalError("token", new Object[] { "=" });
/*      */         }
/*  854 */         this.type = this.scanner.next();
/*      */         
/*  856 */         char[] space2 = null;
/*  857 */         if (this.type == 1) {
/*  858 */           space2 = getCurrentValue();
/*  859 */           this.type = this.scanner.next();
/*      */         } 
/*  861 */         if (this.type != 25 && this.type != 16)
/*      */         {
/*  863 */           throw fatalError("string", null);
/*      */         }
/*      */         
/*  866 */         char valueDelim = this.scanner.getStringDelimiter();
/*  867 */         boolean hasEntityRef = false;
/*      */         
/*  869 */         StringBuffer sb = new StringBuffer();
/*  870 */         sb.append(getCurrentValue());
/*      */         while (true) {
/*  872 */           this.scanner.clearBuffer();
/*  873 */           this.type = this.scanner.next();
/*  874 */           switch (this.type) {
/*      */             case 16:
/*      */             case 17:
/*      */             case 18:
/*      */             case 25:
/*  879 */               sb.append(getCurrentValue());
/*      */               continue;
/*      */             case 12:
/*  882 */               hasEntityRef = true;
/*  883 */               sb.append("&#");
/*  884 */               sb.append(getCurrentValue());
/*  885 */               sb.append(";");
/*      */               continue;
/*      */             case 13:
/*  888 */               hasEntityRef = true;
/*  889 */               sb.append("&");
/*  890 */               sb.append(getCurrentValue());
/*  891 */               sb.append(";");
/*      */               continue;
/*      */           } 
/*      */ 
/*      */           
/*      */           break;
/*      */         } 
/*  898 */         attributes.add(new OutputManager.AttributeInfo(space, attName, space1, space2, new String(sb), valueDelim, hasEntityRef));
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/*  904 */         space = null;
/*      */       } 
/*      */     } 
/*  907 */     this.output.printElementStart(name, attributes, space);
/*      */     
/*  909 */     switch (this.type)
/*      */     { default:
/*  911 */         throw fatalError("xml", null);
/*      */       case 19:
/*  913 */         this.output.printElementEnd(null, null);
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/*  938 */         this.type = this.scanner.next();
/*  939 */         return nameStr;case 20: break; }  this.output.printCharacter('>'); this.type = this.scanner.next(); printContent(allowSpaceAtStart(nameStr)); if (this.type != 10) throw fatalError("end.tag", null);  name = getCurrentValue(); this.type = this.scanner.next(); space = null; if (this.type == 1) { space = getCurrentValue(); this.type = this.scanner.next(); }  this.output.printElementEnd(name, space); if (this.type != 20) throw fatalError("end", null);  this.type = this.scanner.next(); return nameStr;
/*      */   }
/*      */ 
/*      */   
/*  943 */   boolean allowSpaceAtStart(String tagName) { return true; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected void printContent(boolean spaceAtStart) {
/*  960 */     boolean preceedingSpace = false; while (true) {
/*      */       String name;
/*  962 */       switch (this.type) {
/*      */         case 4:
/*  964 */           this.output.printComment(getCurrentValue());
/*  965 */           this.scanner.clearBuffer();
/*  966 */           this.type = this.scanner.next();
/*  967 */           preceedingSpace = false;
/*      */           continue;
/*      */         case 5:
/*  970 */           printPI();
/*  971 */           preceedingSpace = false;
/*      */           continue;
/*      */         case 8:
/*  974 */           preceedingSpace = this.output.printCharacterData(getCurrentValue(), spaceAtStart, preceedingSpace);
/*      */           
/*  976 */           this.scanner.clearBuffer();
/*  977 */           this.type = this.scanner.next();
/*  978 */           spaceAtStart = false;
/*      */           continue;
/*      */         case 11:
/*  981 */           this.type = this.scanner.next();
/*  982 */           if (this.type != 8) {
/*  983 */             throw fatalError("character.data", null);
/*      */           }
/*  985 */           this.output.printCDATASection(getCurrentValue());
/*  986 */           if (this.scanner.next() != 21) {
/*  987 */             throw fatalError("section.end", null);
/*      */           }
/*  989 */           this.scanner.clearBuffer();
/*  990 */           this.type = this.scanner.next();
/*  991 */           preceedingSpace = false;
/*  992 */           spaceAtStart = false;
/*      */           continue;
/*      */         case 9:
/*  995 */           name = printElement();
/*  996 */           spaceAtStart = allowSpaceAtStart(name);
/*      */           continue;
/*      */         case 12:
/*  999 */           this.output.printCharacterEntityReference(getCurrentValue(), spaceAtStart, preceedingSpace);
/*      */ 
/*      */           
/* 1002 */           this.scanner.clearBuffer();
/* 1003 */           this.type = this.scanner.next();
/* 1004 */           spaceAtStart = false;
/* 1005 */           preceedingSpace = false;
/*      */           continue;
/*      */         case 13:
/* 1008 */           this.output.printEntityReference(getCurrentValue(), spaceAtStart);
/* 1009 */           this.scanner.clearBuffer();
/* 1010 */           this.type = this.scanner.next();
/* 1011 */           spaceAtStart = false;
/* 1012 */           preceedingSpace = false;
/*      */           continue;
/*      */       } 
/*      */       break;
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected void printNotation() {
/* 1027 */     int t = this.scanner.next();
/* 1028 */     if (t != 1) {
/* 1029 */       throw fatalError("space", null);
/*      */     }
/* 1031 */     char[] space1 = getCurrentValue();
/* 1032 */     t = this.scanner.next();
/*      */     
/* 1034 */     if (t != 14) {
/* 1035 */       throw fatalError("name", null);
/*      */     }
/* 1037 */     char[] name = getCurrentValue();
/* 1038 */     t = this.scanner.next();
/*      */     
/* 1040 */     if (t != 1) {
/* 1041 */       throw fatalError("space", null);
/*      */     }
/* 1043 */     char[] space2 = getCurrentValue();
/* 1044 */     t = this.scanner.next();
/*      */     
/* 1046 */     String externalId = null;
/* 1047 */     char[] space3 = null;
/* 1048 */     char[] string1 = null;
/* 1049 */     char string1Delim = Character.MIN_VALUE;
/* 1050 */     char[] space4 = null;
/* 1051 */     char[] string2 = null;
/* 1052 */     char string2Delim = Character.MIN_VALUE;
/*      */     
/* 1054 */     switch (t) {
/*      */       default:
/* 1056 */         throw fatalError("notation.definition", null);
/*      */       case 27:
/* 1058 */         externalId = "PUBLIC";
/*      */         
/* 1060 */         t = this.scanner.next();
/* 1061 */         if (t != 1) {
/* 1062 */           throw fatalError("space", null);
/*      */         }
/* 1064 */         space3 = getCurrentValue();
/* 1065 */         t = this.scanner.next();
/*      */         
/* 1067 */         if (t != 25) {
/* 1068 */           throw fatalError("string", null);
/*      */         }
/* 1070 */         string1 = getCurrentValue();
/* 1071 */         string1Delim = this.scanner.getStringDelimiter();
/* 1072 */         t = this.scanner.next();
/*      */         
/* 1074 */         if (t == 1) {
/* 1075 */           space4 = getCurrentValue();
/* 1076 */           t = this.scanner.next();
/*      */           
/* 1078 */           if (t == 25) {
/* 1079 */             string2 = getCurrentValue();
/* 1080 */             string2Delim = this.scanner.getStringDelimiter();
/* 1081 */             t = this.scanner.next();
/*      */           } 
/*      */         } 
/*      */         break;
/*      */       
/*      */       case 26:
/* 1087 */         externalId = "SYSTEM";
/*      */         
/* 1089 */         t = this.scanner.next();
/* 1090 */         if (t != 1) {
/* 1091 */           throw fatalError("space", null);
/*      */         }
/* 1093 */         space3 = getCurrentValue();
/* 1094 */         t = this.scanner.next();
/*      */         
/* 1096 */         if (t != 25) {
/* 1097 */           throw fatalError("string", null);
/*      */         }
/* 1099 */         string1 = getCurrentValue();
/* 1100 */         string1Delim = this.scanner.getStringDelimiter();
/* 1101 */         t = this.scanner.next();
/*      */         break;
/*      */     } 
/* 1104 */     char[] space5 = null;
/* 1105 */     if (t == 1) {
/* 1106 */       space5 = getCurrentValue();
/* 1107 */       t = this.scanner.next();
/*      */     } 
/* 1109 */     if (t != 20) {
/* 1110 */       throw fatalError("end", null);
/*      */     }
/* 1112 */     this.output.printNotation(space1, name, space2, externalId, space3, string1, string1Delim, space4, string2, string2Delim, space5);
/*      */ 
/*      */ 
/*      */     
/* 1116 */     this.scanner.next();
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected void printAttlist() {
/* 1126 */     this.type = this.scanner.next();
/* 1127 */     if (this.type != 1) {
/* 1128 */       throw fatalError("space", null);
/*      */     }
/* 1130 */     char[] space = getCurrentValue();
/* 1131 */     this.type = this.scanner.next();
/*      */     
/* 1133 */     if (this.type != 14) {
/* 1134 */       throw fatalError("name", null);
/*      */     }
/* 1136 */     char[] name = getCurrentValue();
/* 1137 */     this.type = this.scanner.next();
/*      */     
/* 1139 */     this.output.printAttlistStart(space, name);
/*      */     
/* 1141 */     while (this.type == 1) {
/* 1142 */       List names; space = getCurrentValue();
/* 1143 */       this.type = this.scanner.next();
/*      */       
/* 1145 */       if (this.type != 14) {
/*      */         break;
/*      */       }
/* 1148 */       name = getCurrentValue();
/* 1149 */       this.type = this.scanner.next();
/*      */       
/* 1151 */       if (this.type != 1) {
/* 1152 */         throw fatalError("space", null);
/*      */       }
/* 1154 */       char[] space2 = getCurrentValue();
/* 1155 */       this.type = this.scanner.next();
/*      */       
/* 1157 */       this.output.printAttName(space, name, space2);
/*      */       
/* 1159 */       switch (this.type) {
/*      */         case 45:
/*      */         case 46:
/*      */         case 47:
/*      */         case 48:
/*      */         case 49:
/*      */         case 50:
/*      */         case 51:
/*      */         case 52:
/* 1168 */           this.output.printCharacters(getCurrentValue());
/* 1169 */           this.type = this.scanner.next();
/*      */           break;
/*      */         case 57:
/* 1172 */           this.output.printCharacters(getCurrentValue());
/* 1173 */           this.type = this.scanner.next();
/*      */           
/* 1175 */           if (this.type != 1) {
/* 1176 */             throw fatalError("space", null);
/*      */           }
/* 1178 */           this.output.printSpaces(getCurrentValue(), false);
/* 1179 */           this.type = this.scanner.next();
/*      */           
/* 1181 */           if (this.type != 40) {
/* 1182 */             throw fatalError("left.brace", null);
/*      */           }
/* 1184 */           this.type = this.scanner.next();
/*      */           
/* 1186 */           names = new LinkedList();
/* 1187 */           space = null;
/*      */           
/* 1189 */           if (this.type == 1) {
/* 1190 */             space = getCurrentValue();
/* 1191 */             this.type = this.scanner.next();
/*      */           } 
/*      */           
/* 1194 */           if (this.type != 14) {
/* 1195 */             throw fatalError("name", null);
/*      */           }
/* 1197 */           name = getCurrentValue();
/* 1198 */           this.type = this.scanner.next();
/*      */           
/* 1200 */           space2 = null;
/* 1201 */           if (this.type == 1) {
/* 1202 */             space2 = getCurrentValue();
/* 1203 */             this.type = this.scanner.next();
/*      */           } 
/*      */           
/* 1206 */           names.add(new OutputManager.NameInfo(space, name, space2));
/*      */           
/*      */           while (true) {
/* 1209 */             switch (this.type) { default:
/*      */                 break;
/*      */               case 42:
/*      */                 break; }
/* 1213 */              this.type = this.scanner.next();
/*      */             
/* 1215 */             space = null;
/* 1216 */             if (this.type == 1) {
/* 1217 */               space = getCurrentValue();
/* 1218 */               this.type = this.scanner.next();
/*      */             } 
/*      */             
/* 1221 */             if (this.type != 14) {
/* 1222 */               throw fatalError("name", null);
/*      */             }
/* 1224 */             name = getCurrentValue();
/* 1225 */             this.type = this.scanner.next();
/*      */             
/* 1227 */             space2 = null;
/* 1228 */             if (this.type == 1) {
/* 1229 */               space2 = getCurrentValue();
/* 1230 */               this.type = this.scanner.next();
/*      */             } 
/*      */             
/* 1233 */             names.add(new OutputManager.NameInfo(space, name, space2));
/*      */           } 
/*      */           
/* 1236 */           if (this.type != 41) {
/* 1237 */             throw fatalError("right.brace", null);
/*      */           }
/*      */           
/* 1240 */           this.output.printEnumeration(names);
/* 1241 */           this.type = this.scanner.next();
/*      */           break;
/*      */         case 40:
/* 1244 */           this.type = this.scanner.next();
/*      */           
/* 1246 */           names = new LinkedList();
/* 1247 */           space = null;
/*      */           
/* 1249 */           if (this.type == 1) {
/* 1250 */             space = getCurrentValue();
/* 1251 */             this.type = this.scanner.next();
/*      */           } 
/*      */           
/* 1254 */           if (this.type != 56) {
/* 1255 */             throw fatalError("nmtoken", null);
/*      */           }
/* 1257 */           name = getCurrentValue();
/* 1258 */           this.type = this.scanner.next();
/*      */           
/* 1260 */           space2 = null;
/* 1261 */           if (this.type == 1) {
/* 1262 */             space2 = getCurrentValue();
/* 1263 */             this.type = this.scanner.next();
/*      */           } 
/*      */           
/* 1266 */           names.add(new OutputManager.NameInfo(space, name, space2));
/*      */           
/*      */           while (true) {
/* 1269 */             switch (this.type) { default:
/*      */                 break;
/*      */               case 42:
/*      */                 break; }
/* 1273 */              this.type = this.scanner.next();
/*      */             
/* 1275 */             space = null;
/* 1276 */             if (this.type == 1) {
/* 1277 */               space = getCurrentValue();
/* 1278 */               this.type = this.scanner.next();
/*      */             } 
/*      */             
/* 1281 */             if (this.type != 56) {
/* 1282 */               throw fatalError("nmtoken", null);
/*      */             }
/* 1284 */             name = getCurrentValue();
/* 1285 */             this.type = this.scanner.next();
/*      */             
/* 1287 */             space2 = null;
/* 1288 */             if (this.type == 1) {
/* 1289 */               space2 = getCurrentValue();
/* 1290 */               this.type = this.scanner.next();
/*      */             } 
/*      */             
/* 1293 */             names.add(new OutputManager.NameInfo(space, name, space2));
/*      */           } 
/*      */           
/* 1296 */           if (this.type != 41) {
/* 1297 */             throw fatalError("right.brace", null);
/*      */           }
/*      */           
/* 1300 */           this.output.printEnumeration(names);
/* 1301 */           this.type = this.scanner.next();
/*      */           break;
/*      */       } 
/*      */       
/* 1305 */       if (this.type == 1) {
/* 1306 */         this.output.printSpaces(getCurrentValue(), true);
/* 1307 */         this.type = this.scanner.next();
/*      */       } 
/*      */       
/* 1310 */       switch (this.type) {
/*      */         default:
/* 1312 */           throw fatalError("default.decl", null);
/*      */         case 53:
/*      */         case 54:
/* 1315 */           this.output.printCharacters(getCurrentValue());
/* 1316 */           this.type = this.scanner.next();
/*      */           break;
/*      */         case 55:
/* 1319 */           this.output.printCharacters(getCurrentValue());
/* 1320 */           this.type = this.scanner.next();
/*      */           
/* 1322 */           if (this.type != 1) {
/* 1323 */             throw fatalError("space", null);
/*      */           }
/* 1325 */           this.output.printSpaces(getCurrentValue(), false);
/* 1326 */           this.type = this.scanner.next();
/*      */           
/* 1328 */           if (this.type != 25 && this.type != 16)
/*      */           {
/* 1330 */             throw fatalError("space", null);
/*      */           }
/*      */         case 16:
/*      */         case 25:
/* 1334 */           this.output.printCharacter(this.scanner.getStringDelimiter());
/* 1335 */           this.output.printCharacters(getCurrentValue());
/*      */           while (true) {
/* 1337 */             this.type = this.scanner.next();
/* 1338 */             switch (this.type) {
/*      */               case 16:
/*      */               case 17:
/*      */               case 18:
/*      */               case 25:
/* 1343 */                 this.output.printCharacters(getCurrentValue());
/*      */                 continue;
/*      */               case 12:
/* 1346 */                 this.output.printString("&#");
/* 1347 */                 this.output.printCharacters(getCurrentValue());
/* 1348 */                 this.output.printCharacter(';');
/*      */                 continue;
/*      */               case 13:
/* 1351 */                 this.output.printCharacter('&');
/* 1352 */                 this.output.printCharacters(getCurrentValue());
/* 1353 */                 this.output.printCharacter(';');
/*      */                 continue;
/*      */             } 
/*      */             
/*      */             break;
/*      */           } 
/* 1359 */           this.output.printCharacter(this.scanner.getStringDelimiter()); break;
/*      */       } 
/* 1361 */       space = null;
/*      */     } 
/*      */     
/* 1364 */     if (this.type != 20) {
/* 1365 */       throw fatalError("end", null);
/*      */     }
/* 1367 */     this.output.printAttlistEnd(space);
/* 1368 */     this.type = this.scanner.next();
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected void printEntityDeclaration() {
/*      */     char sd;
/* 1378 */     this.writer.write("<!ENTITY");
/*      */     
/* 1380 */     this.type = this.scanner.next();
/* 1381 */     if (this.type != 1) {
/* 1382 */       throw fatalError("space", null);
/*      */     }
/* 1384 */     this.writer.write(getCurrentValue());
/* 1385 */     this.type = this.scanner.next();
/*      */     
/* 1387 */     boolean pe = false;
/*      */     
/* 1389 */     switch (this.type) {
/*      */       default:
/* 1391 */         throw fatalError("xml", null);
/*      */       case 14:
/* 1393 */         this.writer.write(getCurrentValue());
/* 1394 */         this.type = this.scanner.next();
/*      */         break;
/*      */       case 58:
/* 1397 */         pe = true;
/* 1398 */         this.writer.write(37);
/* 1399 */         this.type = this.scanner.next();
/*      */         
/* 1401 */         if (this.type != 1) {
/* 1402 */           throw fatalError("space", null);
/*      */         }
/* 1404 */         this.writer.write(getCurrentValue());
/* 1405 */         this.type = this.scanner.next();
/*      */         
/* 1407 */         if (this.type != 14) {
/* 1408 */           throw fatalError("name", null);
/*      */         }
/* 1410 */         this.writer.write(getCurrentValue());
/* 1411 */         this.type = this.scanner.next();
/*      */         break;
/*      */     } 
/* 1414 */     if (this.type != 1) {
/* 1415 */       throw fatalError("space", null);
/*      */     }
/* 1417 */     this.writer.write(getCurrentValue());
/* 1418 */     this.type = this.scanner.next();
/*      */     
/* 1420 */     switch (this.type) {
/*      */       case 16:
/*      */       case 25:
/* 1423 */         sd = this.scanner.getStringDelimiter();
/* 1424 */         this.writer.write(sd);
/*      */         while (true) {
/* 1426 */           switch (this.type) {
/*      */             case 16:
/*      */             case 17:
/*      */             case 18:
/*      */             case 25:
/* 1431 */               this.writer.write(getCurrentValue());
/*      */               break;
/*      */             case 13:
/* 1434 */               this.writer.write(38);
/* 1435 */               this.writer.write(getCurrentValue());
/* 1436 */               this.writer.write(59);
/*      */               break;
/*      */             case 34:
/* 1439 */               this.writer.write(38);
/* 1440 */               this.writer.write(getCurrentValue());
/* 1441 */               this.writer.write(59);
/*      */               break;
/*      */             default:
/*      */               break;
/*      */           } 
/* 1446 */           this.type = this.scanner.next();
/*      */         } 
/* 1448 */         this.writer.write(sd);
/*      */         
/* 1450 */         if (this.type == 1) {
/* 1451 */           this.writer.write(getCurrentValue());
/* 1452 */           this.type = this.scanner.next();
/*      */         } 
/*      */         
/* 1455 */         if (this.type != 20) {
/* 1456 */           throw fatalError("end", null);
/*      */         }
/* 1458 */         this.writer.write(">");
/* 1459 */         this.type = this.scanner.next();
/*      */         return;
/*      */       case 27:
/* 1462 */         this.writer.write("PUBLIC");
/* 1463 */         this.type = this.scanner.next();
/* 1464 */         if (this.type != 1) {
/* 1465 */           throw fatalError("space", null);
/*      */         }
/* 1467 */         this.type = this.scanner.next();
/* 1468 */         if (this.type != 25) {
/* 1469 */           throw fatalError("string", null);
/*      */         }
/*      */         
/* 1472 */         this.writer.write(" \"");
/* 1473 */         this.writer.write(getCurrentValue());
/* 1474 */         this.writer.write("\" \"");
/*      */         
/* 1476 */         this.type = this.scanner.next();
/* 1477 */         if (this.type != 1) {
/* 1478 */           throw fatalError("space", null);
/*      */         }
/* 1480 */         this.type = this.scanner.next();
/* 1481 */         if (this.type != 25) {
/* 1482 */           throw fatalError("string", null);
/*      */         }
/*      */         
/* 1485 */         this.writer.write(getCurrentValue());
/* 1486 */         this.writer.write(34);
/*      */         break;
/*      */       
/*      */       case 26:
/* 1490 */         this.writer.write("SYSTEM");
/* 1491 */         this.type = this.scanner.next();
/* 1492 */         if (this.type != 1) {
/* 1493 */           throw fatalError("space", null);
/*      */         }
/* 1495 */         this.type = this.scanner.next();
/* 1496 */         if (this.type != 25) {
/* 1497 */           throw fatalError("string", null);
/*      */         }
/* 1499 */         this.writer.write(" \"");
/* 1500 */         this.writer.write(getCurrentValue());
/* 1501 */         this.writer.write(34);
/*      */         break;
/*      */     } 
/* 1504 */     this.type = this.scanner.next();
/* 1505 */     if (this.type == 1) {
/* 1506 */       this.writer.write(getCurrentValue());
/* 1507 */       this.type = this.scanner.next();
/* 1508 */       if (!pe && this.type == 59) {
/* 1509 */         this.writer.write("NDATA");
/* 1510 */         this.type = this.scanner.next();
/* 1511 */         if (this.type != 1) {
/* 1512 */           throw fatalError("space", null);
/*      */         }
/* 1514 */         this.writer.write(getCurrentValue());
/* 1515 */         this.type = this.scanner.next();
/* 1516 */         if (this.type != 14) {
/* 1517 */           throw fatalError("name", null);
/*      */         }
/* 1519 */         this.writer.write(getCurrentValue());
/* 1520 */         this.type = this.scanner.next();
/*      */       } 
/* 1522 */       if (this.type == 1) {
/* 1523 */         this.writer.write(getCurrentValue());
/* 1524 */         this.type = this.scanner.next();
/*      */       } 
/*      */     } 
/*      */     
/* 1528 */     if (this.type != 20) {
/* 1529 */       throw fatalError("end", null);
/*      */     }
/* 1531 */     this.writer.write(62);
/* 1532 */     this.type = this.scanner.next();
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected void printElementDeclaration() {
/* 1542 */     this.writer.write("<!ELEMENT");
/*      */     
/* 1544 */     this.type = this.scanner.next();
/* 1545 */     if (this.type != 1) {
/* 1546 */       throw fatalError("space", null);
/*      */     }
/* 1548 */     this.writer.write(getCurrentValue());
/* 1549 */     this.type = this.scanner.next();
/* 1550 */     switch (this.type)
/*      */     { default:
/* 1552 */         throw fatalError("name", null);
/*      */       case 14:
/* 1554 */         break; }  this.writer.write(getCurrentValue());
/*      */ 
/*      */     
/* 1557 */     this.type = this.scanner.next();
/* 1558 */     if (this.type != 1) {
/* 1559 */       throw fatalError("space", null);
/*      */     }
/* 1561 */     this.writer.write(getCurrentValue());
/*      */     
/* 1563 */     switch (this.type = this.scanner.next()) {
/*      */       case 35:
/* 1565 */         this.writer.write("EMPTY");
/* 1566 */         this.type = this.scanner.next();
/*      */         break;
/*      */       case 36:
/* 1569 */         this.writer.write("ANY");
/* 1570 */         this.type = this.scanner.next();
/*      */         break;
/*      */       case 40:
/* 1573 */         this.writer.write(40);
/* 1574 */         this.type = this.scanner.next();
/* 1575 */         if (this.type == 1) {
/* 1576 */           this.writer.write(getCurrentValue());
/* 1577 */           this.type = this.scanner.next();
/*      */         } 
/* 1579 */         switch (this.type) {
/*      */           case 44:
/* 1581 */             this.writer.write("#PCDATA");
/* 1582 */             this.type = this.scanner.next();
/*      */             
/*      */             while (true) {
/* 1585 */               switch (this.type)
/*      */               { case 1:
/* 1587 */                   this.writer.write(getCurrentValue());
/* 1588 */                   this.type = this.scanner.next();
/*      */                 
/*      */                 case 42:
/* 1591 */                   this.writer.write(124);
/* 1592 */                   this.type = this.scanner.next();
/* 1593 */                   if (this.type == 1) {
/* 1594 */                     this.writer.write(getCurrentValue());
/* 1595 */                     this.type = this.scanner.next();
/*      */                   } 
/* 1597 */                   if (this.type != 14) {
/* 1598 */                     throw fatalError("name", null);
/*      */                   }
/* 1600 */                   this.writer.write(getCurrentValue());
/* 1601 */                   this.type = this.scanner.next();
/*      */                 case 41:
/*      */                   break; } 
/* 1604 */             }  this.writer.write(41);
/* 1605 */             this.type = this.scanner.next();
/*      */             break;
/*      */ 
/*      */ 
/*      */           
/*      */           case 14:
/*      */           case 40:
/* 1612 */             printChildren();
/* 1613 */             if (this.type != 41) {
/* 1614 */               throw fatalError("right.brace", null);
/*      */             }
/* 1616 */             this.writer.write(41);
/* 1617 */             this.type = this.scanner.next();
/* 1618 */             if (this.type == 1) {
/* 1619 */               this.writer.write(getCurrentValue());
/* 1620 */               this.type = this.scanner.next();
/*      */             } 
/* 1622 */             switch (this.type) {
/*      */               case 37:
/* 1624 */                 this.writer.write(63);
/* 1625 */                 this.type = this.scanner.next();
/*      */                 break;
/*      */               case 39:
/* 1628 */                 this.writer.write(42);
/* 1629 */                 this.type = this.scanner.next();
/*      */                 break;
/*      */               case 38:
/* 1632 */                 this.writer.write(43);
/* 1633 */                 this.type = this.scanner.next(); break;
/*      */             }  break;
/*      */         } 
/*      */         break;
/*      */     } 
/* 1638 */     if (this.type == 1) {
/* 1639 */       this.writer.write(getCurrentValue());
/* 1640 */       this.type = this.scanner.next();
/*      */     } 
/*      */     
/* 1643 */     if (this.type != 20) {
/* 1644 */       throw fatalError("end", null);
/*      */     }
/* 1646 */     this.writer.write(62);
/* 1647 */     this.scanner.next();
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected void printChildren() {
/* 1657 */     int op = 0;
/*      */     while (true) {
/* 1659 */       switch (this.type) {
/*      */         default:
/* 1661 */           throw new RuntimeException("Invalid XML");
/*      */         case 14:
/* 1663 */           this.writer.write(getCurrentValue());
/* 1664 */           this.type = this.scanner.next();
/*      */           break;
/*      */         case 40:
/* 1667 */           this.writer.write(40);
/* 1668 */           this.type = this.scanner.next();
/* 1669 */           if (this.type == 1) {
/* 1670 */             this.writer.write(getCurrentValue());
/* 1671 */             this.type = this.scanner.next();
/*      */           } 
/* 1673 */           printChildren();
/* 1674 */           if (this.type != 41) {
/* 1675 */             throw fatalError("right.brace", null);
/*      */           }
/* 1677 */           this.writer.write(41);
/* 1678 */           this.type = this.scanner.next();
/*      */           break;
/*      */       } 
/* 1681 */       if (this.type == 1) {
/* 1682 */         this.writer.write(getCurrentValue());
/* 1683 */         this.type = this.scanner.next();
/*      */       } 
/*      */       
/* 1686 */       switch (this.type) {
/*      */         case 41:
/*      */           break;
/*      */         case 39:
/* 1690 */           this.writer.write(42);
/* 1691 */           this.type = this.scanner.next();
/*      */           break;
/*      */         case 37:
/* 1694 */           this.writer.write(63);
/* 1695 */           this.type = this.scanner.next();
/*      */           break;
/*      */         case 38:
/* 1698 */           this.writer.write(43);
/* 1699 */           this.type = this.scanner.next();
/*      */           break;
/*      */       } 
/*      */       
/* 1703 */       if (this.type == 1) {
/* 1704 */         this.writer.write(getCurrentValue());
/* 1705 */         this.type = this.scanner.next();
/*      */       } 
/*      */       
/* 1708 */       switch (this.type) {
/*      */         case 42:
/* 1710 */           if (op != 0 && op != this.type) {
/* 1711 */             throw new RuntimeException("Invalid XML");
/*      */           }
/* 1713 */           this.writer.write(124);
/* 1714 */           op = this.type;
/* 1715 */           this.type = this.scanner.next();
/*      */           break;
/*      */         case 43:
/* 1718 */           if (op != 0 && op != this.type) {
/* 1719 */             throw new RuntimeException("Invalid XML");
/*      */           }
/* 1721 */           this.writer.write(44);
/* 1722 */           op = this.type;
/* 1723 */           this.type = this.scanner.next();
/*      */           break;
/*      */       } 
/* 1726 */       if (this.type == 1) {
/* 1727 */         this.writer.write(getCurrentValue());
/* 1728 */         this.type = this.scanner.next();
/*      */       } 
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected char[] getCurrentValue() {
/* 1737 */     int off = this.scanner.getStart() + this.scanner.getStartOffset();
/* 1738 */     int len = this.scanner.getEnd() + this.scanner.getEndOffset() - off;
/* 1739 */     char[] result = new char[len];
/* 1740 */     char[] buffer = this.scanner.getBuffer();
/* 1741 */     System.arraycopy(buffer, off, result, 0, len);
/* 1742 */     return result;
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected TranscoderException fatalError(String key, Object[] params) throws TranscoderException {
/* 1750 */     TranscoderException result = new TranscoderException(key);
/* 1751 */     this.errorHandler.fatalError(result);
/* 1752 */     return result;
/*      */   }
/*      */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-transcoder.jar!\org\apache\batik\transcoder\svg2svg\PrettyPrinter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */