/*     */ package org.apache.batik.transcoder.wmf.tosvg;
/*     */ 
/*     */ import java.awt.Color;
/*     */ import java.awt.Font;
/*     */ import java.awt.Rectangle;
/*     */ import java.awt.Shape;
/*     */ import java.awt.font.FontRenderContext;
/*     */ import java.awt.font.TextLayout;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import java.io.BufferedInputStream;
/*     */ import java.io.DataInputStream;
/*     */ import java.io.File;
/*     */ import java.io.FileInputStream;
/*     */ import java.io.IOException;
/*     */ import org.apache.batik.ext.awt.geom.Polygon2D;
/*     */ import org.apache.batik.ext.awt.geom.Polyline2D;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class WMFHeaderProperties
/*     */   extends AbstractWMFReader
/*     */ {
/*  48 */   private static final Integer INTEGER_0 = new Integer(0); protected DataInputStream stream; private int _bleft; private int _bright; private int _btop; private int _bbottom; private int _bwidth; private int _bheight;
/*     */   private int _ileft;
/*     */   private int _iright;
/*     */   private int _itop;
/*     */   private int _ibottom;
/*     */   private float scale;
/*     */   private int startX;
/*     */   private int startY;
/*     */   private int currentHorizAlign;
/*     */   private int currentVertAlign;
/*     */   private WMFFont wf;
/*  59 */   private static final FontRenderContext fontCtx = new FontRenderContext(new AffineTransform(), false, true); private boolean firstEffectivePaint; public static final int PEN = 1; public static final int BRUSH = 2; public static final int FONT = 3; public static final int NULL_PEN = 4; public static final int NULL_BRUSH = 5; public static final int PALETTE = 6; public static final int OBJ_BITMAP = 7; public static final int OBJ_REGION = 8; public WMFHeaderProperties(File wmffile) throws IOException { this.scale = 1.0F; this.startX = 0; this.startY = 0; this.currentHorizAlign = 0; this.currentVertAlign = 0;
/*     */     this.wf = null;
/*  61 */     this.firstEffectivePaint = true;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  76 */     reset();
/*  77 */     this.stream = new DataInputStream(new BufferedInputStream(new FileInputStream(wmffile)));
/*  78 */     read(this.stream);
/*  79 */     this.stream.close(); }
/*     */    public WMFHeaderProperties() {
/*     */     this.scale = 1.0F;
/*     */     this.startX = 0;
/*     */     this.startY = 0;
/*     */     this.currentHorizAlign = 0;
/*     */     this.currentVertAlign = 0;
/*     */     this.wf = null;
/*     */     this.firstEffectivePaint = true;
/*     */   } public void closeResource() {
/*     */     try {
/*  90 */       if (this.stream != null) this.stream.close(); 
/*  91 */     } catch (IOException e) {}
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setFile(File wmffile) throws IOException {
/*  98 */     this.stream = new DataInputStream(new BufferedInputStream(new FileInputStream(wmffile)));
/*  99 */     read(this.stream);
/* 100 */     this.stream.close();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void reset() {
/* 107 */     this.left = 0;
/* 108 */     this.right = 0;
/* 109 */     this.top = 1000;
/* 110 */     this.bottom = 1000;
/* 111 */     this.inch = 84;
/* 112 */     this._bleft = -1;
/* 113 */     this._bright = -1;
/* 114 */     this._btop = -1;
/* 115 */     this._bbottom = -1;
/* 116 */     this._ileft = -1;
/* 117 */     this._iright = -1;
/* 118 */     this._itop = -1;
/* 119 */     this._ibottom = -1;
/* 120 */     this._bwidth = -1;
/* 121 */     this._bheight = -1;
/* 122 */     this.vpW = -1;
/* 123 */     this.vpH = -1;
/* 124 */     this.vpX = 0;
/* 125 */     this.vpY = 0;
/* 126 */     this.startX = 0;
/* 127 */     this.startY = 0;
/* 128 */     this.scaleXY = 1.0F;
/* 129 */     this.firstEffectivePaint = true;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 135 */   public DataInputStream getStream() { return this.stream; }
/*     */ 
/*     */ 
/*     */   
/*     */   protected boolean readRecords(DataInputStream is) throws IOException {
/* 140 */     short functionId = 1;
/* 141 */     int recSize = 0;
/*     */     
/* 143 */     int brushObject = -1;
/* 144 */     int penObject = -1;
/* 145 */     int fontObject = -1;
/*     */ 
/*     */     
/* 148 */     while (functionId > 0) {
/* 149 */       WMFFont wf; Font f; int objIndex, d; String face; int i, lfHeight; byte[] lfFaceName; int lfWidth; TextLayout layout; int len, style, lfPitchAndFamily; String sr; int i, lfQuality, lfClipPrecision; byte[] bstr; int lfHeight, lfOutPrecision, lfWidth, y2, charset, x2, strikeOut; TextLayout layout; int y1, underline, i, italic, x1, x, i; boolean clipped; int y, i, weight; byte[] bitmap; int orient, len, len; Color color; String sr; Rectangle2D.Float rec; Polygon2D pol; int read; Polyline2D pol; Rectangle2D.Float rec; int offset; Rectangle2D.Float rec; Color color; int blue; float dx, dx; int left, i, flag, i, blue, top, escape, left, left, i; float dx; int i, top; float[] _ypts; int green, lenText, left; float dy; byte[] bstr; float[] _ypts; int top, top, green; float dy, dy; int lfWidth, ptCount, red; float[] _xpts; int red, j, j, width; float width; int right, read, pts[], x, right; float _xpts[], widthDst, widthDst; int x, right; float size; int count, bot, colorref, lfHeight, y, count; float heightDst; int len, bot, objIndex, colorref; float heightDst; int count, objIndex, height, y, bot; float height; int penStyle, brushStyle, objIndex, objIndex, mapmode, align; GdiObject gdiObj; int gdiIndex; recSize = readInt(is);
/*     */       
/* 151 */       recSize -= 3;
/*     */       
/* 153 */       functionId = readShort(is);
/* 154 */       if (functionId <= 0) {
/*     */         break;
/*     */       }
/* 157 */       switch (functionId) {
/*     */         case 259:
/* 159 */           mapmode = readShort(is);
/*     */           
/* 161 */           if (mapmode == 8) this.isotropic = false;
/*     */           
/*     */           continue;
/*     */         case 523:
/* 165 */           this.vpY = readShort(is);
/* 166 */           this.vpX = readShort(is);
/*     */           continue;
/*     */         
/*     */         case 524:
/* 170 */           this.vpH = readShort(is);
/* 171 */           this.vpW = readShort(is);
/* 172 */           if (!this.isotropic) this.scaleXY = this.vpW / this.vpH; 
/* 173 */           this.vpW = (int)(this.vpW * this.scaleXY);
/*     */           continue;
/*     */ 
/*     */ 
/*     */         
/*     */         case 762:
/* 179 */           objIndex = 0;
/* 180 */           penStyle = readShort(is);
/*     */           
/* 182 */           readInt(is);
/*     */           
/* 184 */           colorref = readInt(is);
/* 185 */           red = colorref & 0xFF;
/* 186 */           green = (colorref & 0xFF00) >> 8;
/* 187 */           blue = (colorref & 0xFF0000) >> 16;
/* 188 */           color = new Color(red, green, blue);
/*     */           
/* 190 */           if (recSize == 6) readShort(is); 
/* 191 */           if (penStyle == 5) {
/* 192 */             objIndex = addObjectAt(4, color, objIndex); continue;
/*     */           } 
/* 194 */           objIndex = addObjectAt(1, color, objIndex);
/*     */           continue;
/*     */ 
/*     */ 
/*     */ 
/*     */         
/*     */         case 764:
/* 201 */           objIndex = 0;
/* 202 */           brushStyle = readShort(is);
/*     */           
/* 204 */           colorref = readInt(is);
/* 205 */           red = colorref & 0xFF;
/* 206 */           green = (colorref & 0xFF00) >> 8;
/* 207 */           blue = (colorref & 0xFF0000) >> 16;
/* 208 */           color = new Color(red, green, blue);
/*     */           
/* 210 */           readShort(is);
/* 211 */           if (brushStyle == 5) {
/* 212 */             objIndex = addObjectAt(5, color, objIndex); continue;
/*     */           } 
/* 214 */           objIndex = addObjectAt(2, color, objIndex);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 302:
/* 219 */           align = readShort(is);
/*     */           
/* 221 */           if (recSize > 1) for (int i = 1; i < recSize; ) { readShort(is); i++; }
/* 222 */               this.currentHorizAlign = WMFUtilities.getHorizontalAlignment(align);
/* 223 */           this.currentVertAlign = WMFUtilities.getVerticalAlignment(align);
/*     */           continue;
/*     */         
/*     */         case 2610:
/* 227 */           y = readShort(is);
/* 228 */           x = (int)(readShort(is) * this.scaleXY);
/* 229 */           lenText = readShort(is);
/* 230 */           flag = readShort(is);
/* 231 */           read = 4;
/* 232 */           clipped = false;
/* 233 */           x1 = 0; y1 = 0; x2 = 0; y2 = 0;
/*     */ 
/*     */           
/* 236 */           if ((flag & 0x4) != 0) {
/* 237 */             x1 = (int)(readShort(is) * this.scaleXY);
/* 238 */             y1 = readShort(is);
/* 239 */             x2 = (int)(readShort(is) * this.scaleXY);
/* 240 */             y2 = readShort(is);
/* 241 */             read += 4;
/* 242 */             clipped = true;
/*     */           } 
/* 244 */           bstr = new byte[lenText];
/* 245 */           i = 0;
/* 246 */           for (; i < lenText; i++) {
/* 247 */             bstr[i] = is.readByte();
/*     */           }
/* 249 */           sr = WMFUtilities.decodeString(this.wf, bstr);
/*     */           
/* 251 */           read += (lenText + 1) / 2;
/*     */ 
/*     */ 
/*     */           
/* 255 */           if (lenText % 2 != 0) is.readByte();
/*     */           
/* 257 */           if (read < recSize) for (int j = read; j < recSize; ) { readShort(is); j++; }
/* 258 */               layout = new TextLayout(sr, this.wf.font, fontCtx);
/*     */           
/* 260 */           lfWidth = (int)layout.getBounds().getWidth();
/* 261 */           x = (int)layout.getBounds().getX();
/* 262 */           lfHeight = (int)getVerticalAlignmentValue(layout, this.currentVertAlign);
/*     */ 
/*     */           
/* 265 */           resizeBounds(x, y);
/* 266 */           resizeBounds(x + lfWidth, y + lfHeight);
/* 267 */           this.firstEffectivePaint = false;
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 1313:
/*     */         case 1583:
/* 273 */           len = readShort(is);
/* 274 */           read = 1;
/* 275 */           bstr = new byte[len];
/* 276 */           for (i = 0; i < len; i++) {
/* 277 */             bstr[i] = is.readByte();
/*     */           }
/* 279 */           sr = WMFUtilities.decodeString(this.wf, bstr);
/*     */ 
/*     */ 
/*     */ 
/*     */           
/* 284 */           if (len % 2 != 0) is.readByte(); 
/* 285 */           read += (len + 1) / 2;
/*     */           
/* 287 */           y = readShort(is);
/* 288 */           x = (int)(readShort(is) * this.scaleXY);
/* 289 */           read += 2;
/*     */           
/* 291 */           if (read < recSize) for (int j = read; j < recSize; ) { readShort(is); j++; }
/* 292 */               layout = new TextLayout(sr, this.wf.font, fontCtx);
/* 293 */           lfWidth = (int)layout.getBounds().getWidth();
/* 294 */           x = (int)layout.getBounds().getX();
/* 295 */           lfHeight = (int)getVerticalAlignmentValue(layout, this.currentVertAlign);
/*     */ 
/*     */           
/* 298 */           resizeBounds(x, y);
/* 299 */           resizeBounds(x + lfWidth, y + lfHeight);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 763:
/* 304 */           lfHeight = readShort(is);
/* 305 */           size = (int)(this.scaleY * lfHeight);
/* 306 */           lfWidth = readShort(is);
/* 307 */           escape = readShort(is);
/* 308 */           orient = readShort(is);
/* 309 */           weight = readShort(is);
/*     */           
/* 311 */           italic = is.readByte();
/* 312 */           underline = is.readByte();
/* 313 */           strikeOut = is.readByte();
/* 314 */           charset = is.readByte() & 0xFF;
/* 315 */           lfOutPrecision = is.readByte();
/* 316 */           lfClipPrecision = is.readByte();
/* 317 */           lfQuality = is.readByte();
/* 318 */           lfPitchAndFamily = is.readByte();
/*     */           
/* 320 */           style = (italic > 0) ? 2 : 0;
/* 321 */           style |= ((weight > 400) ? 1 : 0);
/*     */ 
/*     */ 
/*     */           
/* 325 */           len = 2 * (recSize - 9);
/* 326 */           lfFaceName = new byte[len];
/*     */           
/* 328 */           for (i = 0; i < len; ) { lfFaceName[i] = is.readByte(); i++; }
/* 329 */            face = new String(lfFaceName);
/*     */ 
/*     */           
/* 332 */           d = 0;
/* 333 */           while (d < face.length() && (Character.isLetterOrDigit(face.charAt(d)) || Character.isWhitespace(face.charAt(d))))
/*     */           {
/* 335 */             d++; } 
/* 336 */           if (d > 0) { face = face.substring(0, d); }
/* 337 */           else { face = "System"; }
/*     */           
/* 339 */           if (size < 0.0F) size = -size; 
/* 340 */           objIndex = 0;
/*     */           
/* 342 */           f = new Font(face, style, (int)size);
/* 343 */           f = f.deriveFont(size);
/* 344 */           wf = new WMFFont(f, charset, underline, strikeOut, italic, weight, orient, escape);
/*     */ 
/*     */           
/* 347 */           objIndex = addObjectAt(3, wf, objIndex);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 1791:
/* 352 */           objIndex = 0;
/* 353 */           for (j = 0; j < recSize; ) { readShort(is); j++; }
/* 354 */            objIndex = addObjectAt(6, INTEGER_0, 0);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 247:
/* 359 */           objIndex = 0;
/* 360 */           for (j = 0; j < recSize; ) { readShort(is); j++; }
/* 361 */            objIndex = addObjectAt(8, INTEGER_0, 0);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 301:
/* 366 */           gdiIndex = readShort(is);
/* 367 */           if ((gdiIndex & 0x80000000) != 0) {
/*     */             continue;
/*     */           }
/* 370 */           gdiObj = getObject(gdiIndex);
/* 371 */           if (!gdiObj.used)
/*     */             continue; 
/* 373 */           switch (gdiObj.type) {
/*     */             case 1:
/* 375 */               penObject = gdiIndex;
/*     */               continue;
/*     */             case 2:
/* 378 */               brushObject = gdiIndex;
/*     */               continue;
/*     */             case 3:
/* 381 */               this.wf = (WMFFont)gdiObj.obj;
/* 382 */               fontObject = gdiIndex;
/*     */               continue;
/*     */             
/*     */             case 4:
/* 386 */               penObject = -1;
/*     */               continue;
/*     */             case 5:
/* 389 */               brushObject = -1;
/*     */               continue;
/*     */           } 
/*     */           
/*     */           continue;
/*     */         case 496:
/* 395 */           gdiIndex = readShort(is);
/* 396 */           gdiObj = getObject(gdiIndex);
/* 397 */           if (gdiIndex == brushObject) { brushObject = -1; }
/* 398 */           else if (gdiIndex == penObject) { penObject = -1; }
/* 399 */           else if (gdiIndex == fontObject) { fontObject = -1; }
/* 400 */            gdiObj.clear();
/*     */           continue;
/*     */         
/*     */         case 531:
/* 404 */           y = readShort(is);
/* 405 */           x = (int)(readShort(is) * this.scaleXY);
/* 406 */           if (penObject >= 0) {
/* 407 */             resizeBounds(this.startX, this.startY);
/* 408 */             resizeBounds(x, y);
/* 409 */             this.firstEffectivePaint = false;
/*     */           } 
/* 411 */           this.startX = x;
/* 412 */           this.startY = y;
/*     */           continue;
/*     */         
/*     */         case 532:
/* 416 */           this.startY = readShort(is);
/* 417 */           this.startX = (int)(readShort(is) * this.scaleXY);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 1336:
/* 422 */           count = readShort(is);
/* 423 */           pts = new int[count];
/* 424 */           ptCount = 0;
/* 425 */           for (i = 0; i < count; i++) {
/* 426 */             pts[i] = readShort(is);
/* 427 */             ptCount += pts[i];
/*     */           } 
/*     */           
/* 430 */           offset = count + 1;
/* 431 */           for (i = 0; i < count; i++) {
/* 432 */             for (int j = 0; j < pts[i]; j++) {
/*     */               
/* 434 */               int x = (int)(readShort(is) * this.scaleXY);
/* 435 */               int y = readShort(is);
/* 436 */               if (brushObject >= 0 || penObject >= 0) resizeBounds(x, y); 
/*     */             } 
/*     */           } 
/* 439 */           this.firstEffectivePaint = false;
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 804:
/* 444 */           count = readShort(is);
/* 445 */           _xpts = new float[count + 1];
/* 446 */           _ypts = new float[count + 1];
/* 447 */           for (i = 0; i < count; i++) {
/* 448 */             _xpts[i] = readShort(is) * this.scaleXY;
/* 449 */             _ypts[i] = readShort(is);
/*     */           } 
/* 451 */           _xpts[count] = _xpts[0];
/* 452 */           _ypts[count] = _ypts[0];
/* 453 */           pol = new Polygon2D(_xpts, _ypts, count);
/* 454 */           paint(brushObject, penObject, pol);
/*     */           continue;
/*     */ 
/*     */ 
/*     */         
/*     */         case 805:
/* 460 */           count = readShort(is);
/* 461 */           _xpts = new float[count];
/* 462 */           _ypts = new float[count];
/* 463 */           for (i = 0; i < count; i++) {
/* 464 */             _xpts[i] = readShort(is) * this.scaleXY;
/* 465 */             _ypts[i] = readShort(is);
/*     */           } 
/* 467 */           pol = new Polyline2D(_xpts, _ypts, count);
/* 468 */           paintWithPen(penObject, pol);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 1046:
/*     */         case 1048:
/*     */         case 1051:
/* 475 */           bot = readShort(is);
/* 476 */           right = (int)(readShort(is) * this.scaleXY);
/* 477 */           top = readShort(is);
/* 478 */           left = (int)(readShort(is) * this.scaleXY);
/* 479 */           rec = new Rectangle2D.Float(left, top, (right - left), (bot - top));
/* 480 */           paint(brushObject, penObject, rec);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 1564:
/* 485 */           readShort(is);
/* 486 */           readShort(is);
/* 487 */           bot = readShort(is);
/* 488 */           right = (int)(readShort(is) * this.scaleXY);
/* 489 */           top = readShort(is);
/* 490 */           left = (int)(readShort(is) * this.scaleXY);
/* 491 */           rec = new Rectangle2D.Float(left, top, (right - left), (bot - top));
/* 492 */           paint(brushObject, penObject, rec);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 2071:
/*     */         case 2074:
/*     */         case 2096:
/* 499 */           readShort(is);
/* 500 */           readShort(is);
/* 501 */           readShort(is);
/* 502 */           readShort(is);
/* 503 */           bot = readShort(is);
/* 504 */           right = (int)(readShort(is) * this.scaleXY);
/* 505 */           top = readShort(is);
/* 506 */           left = (int)(readShort(is) * this.scaleXY);
/* 507 */           rec = new Rectangle2D.Float(left, top, (right - left), (bot - top));
/* 508 */           paint(brushObject, penObject, rec);
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 1565:
/* 513 */           readInt(is);
/* 514 */           height = readShort(is);
/* 515 */           width = (int)(readShort(is) * this.scaleXY);
/* 516 */           left = (int)(readShort(is) * this.scaleXY);
/* 517 */           top = readShort(is);
/* 518 */           if (penObject >= 0) resizeBounds(left, top); 
/* 519 */           if (penObject >= 0) resizeBounds(left + width, top + height);
/*     */           
/*     */           continue;
/*     */ 
/*     */         
/*     */         case 2881:
/* 525 */           is.readInt();
/* 526 */           readShort(is);
/* 527 */           readShort(is);
/* 528 */           readShort(is);
/* 529 */           readShort(is);
/* 530 */           heightDst = readShort(is);
/* 531 */           widthDst = readShort(is) * this.scaleXY;
/* 532 */           dy = readShort(is) * getVpWFactor() * this.inch / AbstractWMFReader.PIXEL_PER_INCH;
/* 533 */           dx = readShort(is) * getVpWFactor() * this.inch / AbstractWMFReader.PIXEL_PER_INCH * this.scaleXY;
/* 534 */           widthDst = widthDst * getVpWFactor() * this.inch / AbstractWMFReader.PIXEL_PER_INCH;
/* 535 */           heightDst = heightDst * getVpHFactor() * this.inch / AbstractWMFReader.PIXEL_PER_INCH;
/* 536 */           resizeImageBounds((int)dx, (int)dy);
/* 537 */           resizeImageBounds((int)(dx + widthDst), (int)(dy + heightDst));
/*     */           
/* 539 */           len = 2 * recSize - 20;
/* 540 */           for (i = 0; i < len; ) { is.readByte(); i++; }
/*     */           
/*     */           continue;
/*     */         case 3907:
/* 544 */           is.readInt();
/* 545 */           readShort(is);
/* 546 */           readShort(is);
/* 547 */           readShort(is);
/* 548 */           readShort(is);
/* 549 */           readShort(is);
/* 550 */           heightDst = readShort(is);
/* 551 */           widthDst = readShort(is) * this.scaleXY;
/* 552 */           dy = readShort(is) * getVpHFactor() * this.inch / AbstractWMFReader.PIXEL_PER_INCH;
/* 553 */           dx = readShort(is) * getVpHFactor() * this.inch / AbstractWMFReader.PIXEL_PER_INCH * this.scaleXY;
/* 554 */           widthDst = widthDst * getVpWFactor() * this.inch / AbstractWMFReader.PIXEL_PER_INCH;
/* 555 */           heightDst = heightDst * getVpHFactor() * this.inch / AbstractWMFReader.PIXEL_PER_INCH;
/* 556 */           resizeImageBounds((int)dx, (int)dy);
/* 557 */           resizeImageBounds((int)(dx + widthDst), (int)(dy + heightDst));
/*     */           
/* 559 */           len = 2 * recSize - 22;
/* 560 */           bitmap = new byte[len];
/* 561 */           for (i = 0; i < len; ) { bitmap[i] = is.readByte(); i++; }
/*     */           
/*     */           continue;
/*     */         case 2368:
/* 565 */           is.readInt();
/* 566 */           readShort(is);
/* 567 */           readShort(is);
/* 568 */           readShort(is);
/* 569 */           height = readShort(is) * this.inch / AbstractWMFReader.PIXEL_PER_INCH * getVpHFactor();
/*     */           
/* 571 */           width = readShort(is) * this.inch / AbstractWMFReader.PIXEL_PER_INCH * getVpWFactor() * this.scaleXY;
/*     */           
/* 573 */           dy = this.inch / AbstractWMFReader.PIXEL_PER_INCH * getVpHFactor() * readShort(is);
/*     */           
/* 575 */           dx = this.inch / AbstractWMFReader.PIXEL_PER_INCH * getVpWFactor() * readShort(is) * this.scaleXY;
/*     */           
/* 577 */           resizeImageBounds((int)dx, (int)dy);
/* 578 */           resizeImageBounds((int)(dx + width), (int)(dy + height));
/*     */           continue;
/*     */       } 
/*     */       
/* 582 */       for (int j = 0; j < recSize; j++) {
/* 583 */         readShort(is);
/*     */       }
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 590 */     if (!this.isAldus) {
/* 591 */       this.width = this.vpW;
/* 592 */       this.height = this.vpH;
/* 593 */       this.right = this.vpX;
/* 594 */       this.left = this.vpX + this.vpW;
/* 595 */       this.top = this.vpY;
/* 596 */       this.bottom = this.vpY + this.vpH;
/*     */     } 
/* 598 */     resetBounds();
/* 599 */     return true;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 606 */   public int getWidthBoundsPixels() { return this._bwidth; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 613 */   public int getHeightBoundsPixels() { return this._bheight; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 620 */   public int getWidthBoundsUnits() { return (int)(this.inch * this._bwidth / AbstractWMFReader.PIXEL_PER_INCH); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 627 */   public int getHeightBoundsUnits() { return (int)(this.inch * this._bheight / AbstractWMFReader.PIXEL_PER_INCH); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 634 */   public int getXOffset() { return this._bleft; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 641 */   public int getYOffset() { return this._btop; }
/*     */ 
/*     */ 
/*     */   
/*     */   private void resetBounds() {
/* 646 */     this.scale = getWidthPixels() / this.vpW;
/* 647 */     if (this._bright != -1) {
/* 648 */       this._bright = (int)(this.scale * (this.vpX + this._bright));
/* 649 */       this._bleft = (int)(this.scale * (this.vpX + this._bleft));
/* 650 */       this._bbottom = (int)(this.scale * (this.vpY + this._bbottom));
/* 651 */       this._btop = (int)(this.scale * (this.vpY + this._btop));
/*     */     } 
/*     */ 
/*     */     
/* 655 */     if (this._iright != -1) {
/* 656 */       this._iright = (int)(this._iright * getWidthPixels() / this.width);
/* 657 */       this._ileft = (int)(this._ileft * getWidthPixels() / this.width);
/* 658 */       this._ibottom = (int)(this._ibottom * getWidthPixels() / this.width);
/* 659 */       this._itop = (int)(this._itop * getWidthPixels() / this.width);
/*     */ 
/*     */       
/* 662 */       if (this._bright == -1 || this._iright > this._bright) this._bright = this._iright; 
/* 663 */       if (this._bleft == -1 || this._ileft < this._bleft) this._bleft = this._ileft; 
/* 664 */       if (this._btop == -1 || this._itop < this._btop) this._btop = this._itop; 
/* 665 */       if (this._bbottom == -1 || this._ibottom > this._bbottom) this._bbottom = this._ibottom;
/*     */     
/*     */     } 
/* 668 */     if (this._bleft != -1 && this._bright != -1) this._bwidth = this._bright - this._bleft; 
/* 669 */     if (this._btop != -1 && this._bbottom != -1) this._bheight = this._bbottom - this._btop;
/*     */   
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   private void resizeBounds(int x, int y) {
/* 676 */     if (this._bleft == -1) { this._bleft = x; }
/* 677 */     else if (x < this._bleft) { this._bleft = x; }
/* 678 */      if (this._bright == -1) { this._bright = x; }
/* 679 */     else if (x > this._bright) { this._bright = x; }
/*     */     
/* 681 */     if (this._btop == -1) { this._btop = y; }
/* 682 */     else if (y < this._btop) { this._btop = y; }
/* 683 */      if (this._bbottom == -1) { this._bbottom = y; }
/* 684 */     else if (y > this._bbottom) { this._bbottom = y; }
/*     */   
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   private void resizeImageBounds(int x, int y) {
/* 691 */     if (this._ileft == -1) { this._ileft = x; }
/* 692 */     else if (x < this._ileft) { this._ileft = x; }
/* 693 */      if (this._iright == -1) { this._iright = x; }
/* 694 */     else if (x > this._iright) { this._iright = x; }
/*     */     
/* 696 */     if (this._itop == -1) { this._itop = y; }
/* 697 */     else if (y < this._itop) { this._itop = y; }
/* 698 */      if (this._ibottom == -1) { this._ibottom = y; }
/* 699 */     else if (y > this._ibottom) { this._ibottom = y; }
/*     */   
/*     */   }
/*     */ 
/*     */   
/*     */   private Color getColorFromObject(int brushObject) {
/* 705 */     Color color = null;
/* 706 */     if (brushObject >= 0) {
/* 707 */       GdiObject gdiObj = getObject(brushObject);
/* 708 */       return (Color)gdiObj.obj;
/* 709 */     }  return null;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void paint(int brushObject, int penObject, Shape shape) {
/* 721 */     if (brushObject >= 0 || penObject >= 0) {
/*     */       Color color;
/* 723 */       if (brushObject >= 0) { color = getColorFromObject(brushObject); }
/* 724 */       else { color = getColorFromObject(penObject); }
/*     */       
/* 726 */       if (!this.firstEffectivePaint || !color.equals(Color.white)) {
/* 727 */         Rectangle rec = shape.getBounds();
/* 728 */         resizeBounds((int)rec.getMinX(), (int)rec.getMinY());
/* 729 */         resizeBounds((int)rec.getMaxX(), (int)rec.getMaxY());
/* 730 */         this.firstEffectivePaint = false;
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void paintWithPen(int penObject, Shape shape) {
/* 744 */     if (penObject >= 0) {
/* 745 */       Color col = getColorFromObject(penObject);
/*     */       
/* 747 */       if (!this.firstEffectivePaint || !col.equals(Color.white)) {
/* 748 */         Rectangle rec = shape.getBounds();
/* 749 */         resizeBounds((int)rec.getMinX(), (int)rec.getMinY());
/* 750 */         resizeBounds((int)rec.getMaxX(), (int)rec.getMaxY());
/* 751 */         this.firstEffectivePaint = false;
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   private float getVerticalAlignmentValue(TextLayout layout, int vertAlign) {
/* 759 */     if (vertAlign == 24) return -layout.getAscent(); 
/* 760 */     if (vertAlign == 0) return layout.getAscent() + layout.getDescent(); 
/* 761 */     return 0.0F;
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-transcoder.jar!\org\apache\batik\transcoder\wmf\tosvg\WMFHeaderProperties.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */