/*      */ package org.apache.batik.transcoder.wmf.tosvg;
/*      */ 
/*      */ import java.awt.BasicStroke;
/*      */ import java.awt.Color;
/*      */ import java.awt.Dimension;
/*      */ import java.awt.Font;
/*      */ import java.awt.Graphics;
/*      */ import java.awt.Graphics2D;
/*      */ import java.awt.Image;
/*      */ import java.awt.Paint;
/*      */ import java.awt.Shape;
/*      */ import java.awt.Stroke;
/*      */ import java.awt.TexturePaint;
/*      */ import java.awt.Toolkit;
/*      */ import java.awt.font.FontRenderContext;
/*      */ import java.awt.font.TextLayout;
/*      */ import java.awt.geom.AffineTransform;
/*      */ import java.awt.geom.Arc2D;
/*      */ import java.awt.geom.Ellipse2D;
/*      */ import java.awt.geom.GeneralPath;
/*      */ import java.awt.geom.Line2D;
/*      */ import java.awt.geom.Point2D;
/*      */ import java.awt.geom.Rectangle2D;
/*      */ import java.awt.geom.RoundRectangle2D;
/*      */ import java.awt.image.BufferedImage;
/*      */ import java.awt.image.ImageObserver;
/*      */ import java.io.BufferedInputStream;
/*      */ import java.text.AttributedCharacterIterator;
/*      */ import java.util.ArrayList;
/*      */ import java.util.Iterator;
/*      */ import java.util.List;
/*      */ import java.util.Stack;
/*      */ import org.apache.batik.ext.awt.geom.Polygon2D;
/*      */ import org.apache.batik.ext.awt.geom.Polyline2D;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public class WMFPainter
/*      */   extends AbstractWMFPainter
/*      */ {
/*      */   private static final int INPUT_BUFFER_SIZE = 30720;
/*   69 */   private static final Integer INTEGER_0 = new Integer(0);
/*      */   
/*      */   private float scale;
/*      */   
/*      */   private float scaleX;
/*      */   
/*      */   private float scaleY;
/*      */   private float conv;
/*      */   private float xOffset;
/*      */   private float yOffset;
/*      */   private float vpX;
/*   80 */   private static BasicStroke solid = new BasicStroke(1.0F, 0, 1);
/*      */   
/*      */   private float vpY;
/*      */   private float vpW;
/*      */   private float vpH;
/*   85 */   private static BasicStroke textSolid = new BasicStroke(1.0F, 0, 1);
/*      */ 
/*      */   
/*      */   private Color frgdColor;
/*      */ 
/*      */   
/*      */   private Color bkgdColor;
/*      */   
/*      */   private boolean opaque;
/*      */   
/*      */   private boolean firstEffectivePaint;
/*      */   
/*      */   private ImageObserver observer;
/*      */   
/*      */   private BufferedInputStream bufStream;
/*      */ 
/*      */   
/*  102 */   public WMFPainter(WMFRecordStore currentStore, float scale) { this(currentStore, 0, 0, scale); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public WMFPainter(WMFRecordStore currentStore, int xOffset, int yOffset, float scale) {
/*      */     this.opaque = false;
/*      */     this.firstEffectivePaint = true;
/*      */     this.observer = new ImageObserver(this)
/*      */       {
/*      */         private final WMFPainter this$0;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/*      */         public boolean imageUpdate(Image img, int flags, int x, int y, int width, int height) { return false; }
/*      */       };
/* 1183 */     this.bufStream = null;
/*      */     setRecordStore(currentStore);
/*      */     TextureFactory.getInstance().reset();
/*      */     this.conv = scale;
/*      */     this.xOffset = -xOffset;
/*      */     this.yOffset = -yOffset;
/*      */     this.scale = currentStore.getWidthPixels() / currentStore.getWidthUnits() * scale;
/*      */     this.scale = this.scale * currentStore.getWidthPixels() / currentStore.getVpW();
/*      */     float xfactor = currentStore.getVpW() / currentStore.getWidthPixels() * currentStore.getWidthUnits() / currentStore.getWidthPixels();
/*      */     float yfactor = currentStore.getVpH() / currentStore.getHeightPixels() * currentStore.getHeightUnits() / currentStore.getHeightPixels();
/*      */     this.xOffset *= xfactor;
/*      */     this.yOffset *= yfactor;
/*      */     this.scaleX = this.scale;
/*      */     this.scaleY = this.scale;
/*      */   }
/*      */   
/*      */   public void paint(Graphics g) {
/*      */     float fontHeight = 10.0F;
/*      */     float fontAngle = 0.0F;
/*      */     float penWidth = 0.0F;
/*      */     float startX = 0.0F;
/*      */     float startY = 0.0F;
/*      */     int brushObject = -1;
/*      */     int penObject = -1;
/*      */     int fontObject = -1;
/*      */     Font font = null;
/*      */     Stack dcStack = new Stack();
/*      */     int numRecords = this.currentStore.getNumRecords();
/*      */     int numObjects = this.currentStore.getNumObjects();
/*      */     this.vpX = this.currentStore.getVpX() * this.scale;
/*      */     this.vpY = this.currentStore.getVpY() * this.scale;
/*      */     this.vpW = this.currentStore.getVpW() * this.scale;
/*      */     this.vpH = this.currentStore.getVpH() * this.scale;
/*      */     if (!this.currentStore.isReading()) {
/*      */       g.setPaintMode();
/*      */       Graphics2D g2d = (Graphics2D)g;
/*      */       g2d.setStroke(solid);
/*      */       brushObject = -1;
/*      */       penObject = -1;
/*      */       fontObject = -1;
/*      */       this.frgdColor = null;
/*      */       this.bkgdColor = Color.white;
/*      */       for (int i = 0; i < numObjects; i++) {
/*      */         GdiObject gdiObj = this.currentStore.getObject(i);
/*      */         gdiObj.clear();
/*      */       } 
/*      */       float w = this.vpW;
/*      */       float h = this.vpH;
/*      */       g2d.setColor(Color.black);
/*      */       for (int iRec = 0; iRec < numRecords; iRec++) {
/*      */         Arc2D.Double arc, arc;
/*      */         double extentAngle, extentAngle, endAngle, endAngle, startAngle, startAngle, cy, cy, cx, cx, yend, yend;
/*      */         WMFFont wf;
/*      */         double xend;
/*      */         int escape;
/*      */         double xend;
/*      */         int orient;
/*      */         double ystart;
/*      */         int strikeOut;
/*      */         double ystart;
/*      */         BufferedImage img, img;
/*      */         int underline;
/*      */         double xstart;
/*      */         byte[] bitmap;
/*      */         double xstart;
/*      */         Font f;
/*      */         byte[] bitmap;
/*      */         float widthDst, widthDst;
/*      */         int objIndex;
/*      */         double bottom;
/*      */         RoundRectangle2D rec;
/*      */         double bottom;
/*      */         float dx;
/*      */         boolean ok;
/*      */         float heightDst, heightDst;
/*      */         int d;
/*      */         float y3;
/*      */         int j;
/*      */         String face;
/*      */         float dx, dy, dx;
/*      */         Paint paint;
/*      */         float x3;
/*      */         Polygon2D pol;
/*      */         Polyline2D pol;
/*      */         float dy;
/*      */         Rectangle2D.Float rec;
/*      */         Ellipse2D.Float el;
/*      */         float top, dy;
/*      */         double right;
/*      */         List v;
/*      */         int style, sx;
/*      */         double right;
/*      */         int weight, sx;
/*      */         float y2, left, y2;
/*      */         int k, k, sy, offset;
/*      */         float y2;
/*      */         int sx;
/*      */         Color color;
/*      */         float x2;
/*      */         boolean ok;
/*      */         double top;
/*      */         Color clr;
/*      */         int ip;
/*      */         float width;
/*      */         int sy;
/*      */         double top;
/*      */         float[] _ypts;
/*      */         Line2D.Float line;
/*      */         float width;
/*      */         int sy;
/*      */         float _ypts[], y1;
/*      */         int italic;
/*      */         float x2, height;
/*      */         byte[] bitmap;
/*      */         float[] _xpts;
/*      */         int charset;
/*      */         float height;
/*      */         int penStyle;
/*      */         float x2;
/*      */         int pts[], width;
/*      */         Paint paint;
/*      */         float _xpts[], y1;
/*      */         int brushStyle, width;
/*      */         float y1, endY, rop;
/*      */         double left;
/*      */         int objIndex, height, numPolygons;
/*      */         float x1, size, endX;
/*      */         Font f;
/*      */         int mode, objIndex;
/*      */         float x1;
/*      */         int count, objIndex, objIndex, count, rop;
/*      */         float rop;
/*      */         int objIndex, height, gdiIndex;
/*      */         GdiObject gdiObject;
/*      */         MetaRecord mr = this.currentStore.getRecord(iRec);
/*      */         switch (mr.functionId) {
/*      */           case 523:
/*      */             this.currentStore.setVpX(this.vpX = -(mr.elementAt(0)));
/*      */             this.currentStore.setVpY(this.vpY = -(mr.elementAt(1)));
/*      */             this.vpX *= this.scale;
/*      */             this.vpY *= this.scale;
/*      */             break;
/*      */           case 0:
/*      */           case 524:
/*      */             this.vpW = mr.elementAt(0);
/*      */             this.vpH = mr.elementAt(1);
/*      */             this.scaleX = this.scale;
/*      */             this.scaleY = this.scale;
/*      */             solid = new BasicStroke(this.scaleX * 2.0F, 0, 1);
/*      */             break;
/*      */           case 762:
/*      */             objIndex = 0;
/*      */             penStyle = mr.elementAt(0);
/*      */             if (penStyle == 5) {
/*      */               Color newClr = Color.white;
/*      */               objIndex = addObjectAt(this.currentStore, 4, newClr, objIndex);
/*      */               break;
/*      */             } 
/*      */             penWidth = mr.elementAt(4);
/*      */             setStroke(g2d, penStyle, penWidth, this.scaleX);
/*      */             color = new Color(mr.elementAt(1), mr.elementAt(2), mr.elementAt(3));
/*      */             objIndex = addObjectAt(this.currentStore, 1, color, objIndex);
/*      */             break;
/*      */           case 764:
/*      */             objIndex = 0;
/*      */             brushStyle = mr.elementAt(0);
/*      */             clr = new Color(mr.elementAt(1), mr.elementAt(2), mr.elementAt(3));
/*      */             if (brushStyle == 0) {
/*      */               objIndex = addObjectAt(this.currentStore, 2, clr, objIndex);
/*      */               break;
/*      */             } 
/*      */             if (brushStyle == 2) {
/*      */               Paint paint1;
/*      */               int hatch = mr.elementAt(4);
/*      */               if (!this.opaque) {
/*      */                 paint1 = TextureFactory.getInstance().getTexture(hatch, clr);
/*      */               } else {
/*      */                 paint1 = TextureFactory.getInstance().getTexture(hatch, clr, this.bkgdColor);
/*      */               } 
/*      */               if (paint1 != null) {
/*      */                 objIndex = addObjectAt(this.currentStore, 2, paint1, objIndex);
/*      */                 break;
/*      */               } 
/*      */               clr = Color.black;
/*      */               objIndex = addObjectAt(this.currentStore, 5, clr, objIndex);
/*      */               break;
/*      */             } 
/*      */             clr = Color.black;
/*      */             objIndex = addObjectAt(this.currentStore, 5, clr, objIndex);
/*      */             break;
/*      */           case 763:
/*      */             size = (int)(this.scaleY * mr.elementAt(0));
/*      */             charset = mr.elementAt(3);
/*      */             italic = mr.elementAt(1);
/*      */             weight = mr.elementAt(2);
/*      */             style = (italic > 0) ? 2 : 0;
/*      */             style |= ((weight > 400) ? 1 : 0);
/*      */             face = ((MetaRecord.StringRecord)mr).text;
/*      */             d = 0;
/*      */             while (d < face.length() && (Character.isLetterOrDigit(face.charAt(d)) || Character.isWhitespace(face.charAt(d))))
/*      */               d++; 
/*      */             if (d > 0) {
/*      */               face = face.substring(0, d);
/*      */             } else {
/*      */               face = "System";
/*      */             } 
/*      */             if (size < 0.0F)
/*      */               size = -size; 
/*      */             objIndex = 0;
/*      */             fontHeight = size;
/*      */             f = new Font(face, style, (int)size);
/*      */             f = f.deriveFont(size);
/*      */             underline = mr.elementAt(4);
/*      */             strikeOut = mr.elementAt(5);
/*      */             orient = mr.elementAt(6);
/*      */             escape = mr.elementAt(7);
/*      */             wf = new WMFFont(f, charset, underline, strikeOut, italic, weight, orient, escape);
/*      */             objIndex = addObjectAt(this.currentStore, 3, wf, objIndex);
/*      */             break;
/*      */           case 248:
/*      */           case 505:
/*      */           case 765:
/*      */           case 1790:
/*      */           case 1791:
/*      */             objIndex = addObjectAt(this.currentStore, 6, INTEGER_0, 0);
/*      */             break;
/*      */           case 247:
/*      */             objIndex = addObjectAt(this.currentStore, 8, INTEGER_0, 0);
/*      */             break;
/*      */           case 301:
/*      */             gdiIndex = mr.elementAt(0);
/*      */             if ((gdiIndex & 0x80000000) != 0)
/*      */               break; 
/*      */             if (gdiIndex >= numObjects) {
/*      */               gdiIndex -= numObjects;
/*      */               switch (gdiIndex) {
/*      */                 case 5:
/*      */                   brushObject = -1;
/*      */                   break;
/*      */                 case 8:
/*      */                   penObject = -1;
/*      */                   break;
/*      */               } 
/*      */               break;
/*      */             } 
/*      */             gdiObject = this.currentStore.getObject(gdiIndex);
/*      */             if (!gdiObject.used)
/*      */               break; 
/*      */             switch (gdiObject.type) {
/*      */               case 1:
/*      */                 g2d.setColor((Color)gdiObject.obj);
/*      */                 penObject = gdiIndex;
/*      */                 break;
/*      */               case 2:
/*      */                 if (gdiObject.obj instanceof Color) {
/*      */                   g2d.setColor((Color)gdiObject.obj);
/*      */                 } else if (gdiObject.obj instanceof Paint) {
/*      */                   g2d.setPaint((Paint)gdiObject.obj);
/*      */                 } else {
/*      */                   g2d.setPaint(getPaint((byte[])gdiObject.obj));
/*      */                 } 
/*      */                 brushObject = gdiIndex;
/*      */                 break;
/*      */               case 3:
/*      */                 this.wmfFont = (WMFFont)gdiObject.obj;
/*      */                 f = this.wmfFont.font;
/*      */                 g2d.setFont(f);
/*      */                 fontObject = gdiIndex;
/*      */                 break;
/*      */               case 4:
/*      */                 penObject = -1;
/*      */                 break;
/*      */               case 5:
/*      */                 brushObject = -1;
/*      */                 break;
/*      */             } 
/*      */             break;
/*      */           case 496:
/*      */             gdiIndex = mr.elementAt(0);
/*      */             gdiObject = this.currentStore.getObject(gdiIndex);
/*      */             if (gdiIndex == brushObject) {
/*      */               brushObject = -1;
/*      */             } else if (gdiIndex == penObject) {
/*      */               penObject = -1;
/*      */             } else if (gdiIndex == fontObject) {
/*      */               fontObject = -1;
/*      */             } 
/*      */             gdiObject.clear();
/*      */             break;
/*      */           case 1336:
/*      */             numPolygons = mr.elementAt(0);
/*      */             pts = new int[numPolygons];
/*      */             for (ip = 0; ip < numPolygons; ip++)
/*      */               pts[ip] = mr.elementAt(ip + 1); 
/*      */             offset = numPolygons + 1;
/*      */             v = new ArrayList(numPolygons);
/*      */             for (j = 0; j < numPolygons; j++) {
/*      */               int count = pts[j];
/*      */               float[] xpts = new float[count];
/*      */               float[] ypts = new float[count];
/*      */               for (int k = 0; k < count; k++) {
/*      */                 xpts[k] = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(offset + k * 2));
/*      */                 ypts[k] = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(offset + k * 2 + 1));
/*      */               } 
/*      */               offset += count * 2;
/*      */               Polygon2D pol = new Polygon2D(xpts, ypts, count);
/*      */               v.add(pol);
/*      */             } 
/*      */             if (brushObject >= 0) {
/*      */               setBrushPaint(this.currentStore, g2d, brushObject);
/*      */               fillPolyPolygon(g2d, v);
/*      */               this.firstEffectivePaint = false;
/*      */             } 
/*      */             if (penObject >= 0) {
/*      */               setPenColor(this.currentStore, g2d, penObject);
/*      */               drawPolyPolygon(g2d, v);
/*      */               this.firstEffectivePaint = false;
/*      */             } 
/*      */             break;
/*      */           case 804:
/*      */             count = mr.elementAt(0);
/*      */             _xpts = new float[count];
/*      */             _ypts = new float[count];
/*      */             for (k = 0; k < count; k++) {
/*      */               _xpts[k] = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(k * 2 + 1));
/*      */               _ypts[k] = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(k * 2 + 2));
/*      */             } 
/*      */             pol = new Polygon2D(_xpts, _ypts, count);
/*      */             paint(brushObject, penObject, pol, g2d);
/*      */             break;
/*      */           case 532:
/*      */             startX = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(0));
/*      */             startY = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(1));
/*      */             break;
/*      */           case 531:
/*      */             endX = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(0));
/*      */             endY = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(1));
/*      */             line = new Line2D.Float(startX, startY, endX, endY);
/*      */             paintWithPen(penObject, line, g2d);
/*      */             startX = endX;
/*      */             startY = endY;
/*      */             break;
/*      */           case 805:
/*      */             count = mr.elementAt(0);
/*      */             _xpts = new float[count];
/*      */             _ypts = new float[count];
/*      */             for (k = 0; k < count; k++) {
/*      */               _xpts[k] = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(k * 2 + 1));
/*      */               _ypts[k] = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(k * 2 + 2));
/*      */             } 
/*      */             pol = new Polyline2D(_xpts, _ypts, count);
/*      */             paintWithPen(penObject, pol, g2d);
/*      */             break;
/*      */           case 1051:
/*      */             x1 = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(0));
/*      */             x2 = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(2));
/*      */             y1 = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(1));
/*      */             y2 = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(3));
/*      */             rec = new Rectangle2D.Float(x1, y1, x2 - x1, y2 - y1);
/*      */             paint(brushObject, penObject, rec, g2d);
/*      */             break;
/*      */           case 1564:
/*      */             x1 = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(0));
/*      */             x2 = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(2));
/*      */             x3 = this.scaleX * mr.elementAt(4);
/*      */             y1 = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(1));
/*      */             y2 = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(3));
/*      */             y3 = this.scaleY * mr.elementAt(5);
/*      */             rec = new RoundRectangle2D.Float(x1, y1, x2 - x1, y2 - y1, x3, y3);
/*      */             paint(brushObject, penObject, rec, g2d);
/*      */             break;
/*      */           case 1048:
/*      */             x1 = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(0));
/*      */             x2 = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(2));
/*      */             y1 = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(1));
/*      */             y2 = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(3));
/*      */             el = new Ellipse2D.Float(x1, y1, x2 - x1, y2 - y1);
/*      */             paint(brushObject, penObject, el, g2d);
/*      */             break;
/*      */           case 302:
/*      */             this.currentHorizAlign = WMFUtilities.getHorizontalAlignment(mr.elementAt(0));
/*      */             this.currentVertAlign = WMFUtilities.getVerticalAlignment(mr.elementAt(0));
/*      */             break;
/*      */           case 521:
/*      */             this.frgdColor = new Color(mr.elementAt(0), mr.elementAt(1), mr.elementAt(2));
/*      */             g2d.setColor(this.frgdColor);
/*      */             break;
/*      */           case 513:
/*      */             this.bkgdColor = new Color(mr.elementAt(0), mr.elementAt(1), mr.elementAt(2));
/*      */             g2d.setColor(this.bkgdColor);
/*      */             break;
/*      */           case 2610:
/*      */             try {
/*      */               byte[] bstr = ((MetaRecord.ByteRecord)mr).bstr;
/*      */               String sr = WMFUtilities.decodeString(this.wmfFont, bstr);
/*      */               float x = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(0));
/*      */               float y = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(1));
/*      */               if (this.frgdColor != null) {
/*      */                 g2d.setColor(this.frgdColor);
/*      */               } else {
/*      */                 g2d.setColor(Color.black);
/*      */               } 
/*      */               FontRenderContext frc = g2d.getFontRenderContext();
/*      */               Point2D.Double pen = new Point2D.Double(0.0D, 0.0D);
/*      */               GeneralPath gp = new GeneralPath(1);
/*      */               TextLayout layout = new TextLayout(sr, g2d.getFont(), frc);
/*      */               int flag = mr.elementAt(2);
/*      */               int x1 = 0, y1 = 0, x2 = 0, y2 = 0;
/*      */               boolean clipped = false;
/*      */               Shape clip = null;
/*      */               if ((flag & 0x4) != 0) {
/*      */                 clipped = true;
/*      */                 x1 = mr.elementAt(3);
/*      */                 y1 = mr.elementAt(4);
/*      */                 x2 = mr.elementAt(5);
/*      */                 y2 = mr.elementAt(6);
/*      */                 clip = g2d.getClip();
/*      */                 g2d.setClip(x1, y1, x2, y2);
/*      */               } 
/*      */               this.firstEffectivePaint = false;
/*      */               y += getVerticalAlignmentValue(layout, this.currentVertAlign);
/*      */               drawString(flag, g2d, getCharacterIterator(g2d, sr, this.wmfFont, this.currentHorizAlign), x, y, layout, this.wmfFont, this.currentHorizAlign);
/*      */               if (clipped)
/*      */                 g2d.setClip(clip); 
/*      */             } catch (Exception x1) {
/*      */               Exception e;
/*      */             } 
/*      */             break;
/*      */           case 1313:
/*      */           case 1583:
/*      */             try {
/*      */               byte[] bstr = ((MetaRecord.ByteRecord)mr).bstr;
/*      */               String sr = WMFUtilities.decodeString(this.wmfFont, bstr);
/*      */               float x = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(0));
/*      */               float y = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(1));
/*      */               if (this.frgdColor != null) {
/*      */                 g2d.setColor(this.frgdColor);
/*      */               } else {
/*      */                 g2d.setColor(Color.black);
/*      */               } 
/*      */               FontRenderContext frc = g2d.getFontRenderContext();
/*      */               Point2D.Double pen = new Point2D.Double(0.0D, 0.0D);
/*      */               GeneralPath gp = new GeneralPath(1);
/*      */               TextLayout layout = new TextLayout(sr, g2d.getFont(), frc);
/*      */               this.firstEffectivePaint = false;
/*      */               y += getVerticalAlignmentValue(layout, this.currentVertAlign);
/*      */               drawString(-1, g2d, getCharacterIterator(g2d, sr, this.wmfFont), x, y, layout, this.wmfFont, this.currentHorizAlign);
/*      */             } catch (Exception x1) {
/*      */               Exception e;
/*      */             } 
/*      */             break;
/*      */           case 2071:
/*      */           case 2074:
/*      */             left = (this.scaleX * (this.vpX + this.xOffset + mr.elementAt(0)));
/*      */             top = (this.scaleY * (this.vpY + this.yOffset + mr.elementAt(1)));
/*      */             right = (this.scaleX * (this.vpX + this.xOffset + mr.elementAt(2)));
/*      */             bottom = (this.scaleY * (this.vpY + this.yOffset + mr.elementAt(3)));
/*      */             xstart = (this.scaleX * (this.vpX + this.xOffset + mr.elementAt(4)));
/*      */             ystart = (this.scaleY * (this.vpY + this.yOffset + mr.elementAt(5)));
/*      */             xend = (this.scaleX * (this.vpX + this.xOffset + mr.elementAt(6)));
/*      */             yend = (this.scaleY * (this.vpY + this.yOffset + mr.elementAt(7)));
/*      */             setBrushPaint(this.currentStore, g2d, brushObject);
/*      */             cx = left + (right - left) / 2.0D;
/*      */             cy = top + (bottom - top) / 2.0D;
/*      */             startAngle = -Math.toDegrees(Math.atan2(ystart - cy, xstart - cx));
/*      */             endAngle = -Math.toDegrees(Math.atan2(yend - cy, xend - cx));
/*      */             extentAngle = endAngle - startAngle;
/*      */             if (extentAngle < 0.0D)
/*      */               extentAngle += 360.0D; 
/*      */             if (startAngle < 0.0D)
/*      */               startAngle += 360.0D; 
/*      */             arc = new Arc2D.Double(left, top, right - left, bottom - top, startAngle, extentAngle, 0);
/*      */             if (mr.functionId == 2071) {
/*      */               g2d.draw(arc);
/*      */             } else {
/*      */               g2d.fill(arc);
/*      */             } 
/*      */             this.firstEffectivePaint = false;
/*      */             break;
/*      */           case 2096:
/*      */             left = (this.scaleX * (this.vpX + this.xOffset + mr.elementAt(0)));
/*      */             top = (this.scaleY * (this.vpY + this.yOffset + mr.elementAt(1)));
/*      */             right = (this.scaleX * (this.vpX + this.xOffset + mr.elementAt(2)));
/*      */             bottom = (this.scaleY * (this.vpY + this.yOffset + mr.elementAt(3)));
/*      */             xstart = (this.scaleX * (this.vpX + this.xOffset + mr.elementAt(4)));
/*      */             ystart = (this.scaleY * (this.vpY + this.yOffset + mr.elementAt(5)));
/*      */             xend = (this.scaleX * (this.vpX + this.xOffset + mr.elementAt(6)));
/*      */             yend = (this.scaleY * (this.vpY + this.yOffset + mr.elementAt(7)));
/*      */             setBrushPaint(this.currentStore, g2d, brushObject);
/*      */             cx = left + (right - left) / 2.0D;
/*      */             cy = top + (bottom - top) / 2.0D;
/*      */             startAngle = -Math.toDegrees(Math.atan2(ystart - cy, xstart - cx));
/*      */             endAngle = -Math.toDegrees(Math.atan2(yend - cy, xend - cx));
/*      */             extentAngle = endAngle - startAngle;
/*      */             if (extentAngle < 0.0D)
/*      */               extentAngle += 360.0D; 
/*      */             if (startAngle < 0.0D)
/*      */               startAngle += 360.0D; 
/*      */             arc = new Arc2D.Double(left, top, right - left, bottom - top, startAngle, extentAngle, 1);
/*      */             paint(brushObject, penObject, arc, g2d);
/*      */             this.firstEffectivePaint = false;
/*      */             break;
/*      */           case 30:
/*      */             dcStack.push(new Float(penWidth));
/*      */             dcStack.push(new Float(startX));
/*      */             dcStack.push(new Float(startY));
/*      */             dcStack.push(new Integer(brushObject));
/*      */             dcStack.push(new Integer(penObject));
/*      */             dcStack.push(new Integer(fontObject));
/*      */             dcStack.push(this.frgdColor);
/*      */             dcStack.push(this.bkgdColor);
/*      */             break;
/*      */           case 295:
/*      */             this.bkgdColor = (Color)dcStack.pop();
/*      */             this.frgdColor = (Color)dcStack.pop();
/*      */             fontObject = ((Integer)dcStack.pop()).intValue();
/*      */             penObject = ((Integer)dcStack.pop()).intValue();
/*      */             brushObject = ((Integer)dcStack.pop()).intValue();
/*      */             startY = ((Float)dcStack.pop()).floatValue();
/*      */             startX = ((Float)dcStack.pop()).floatValue();
/*      */             penWidth = ((Float)dcStack.pop()).floatValue();
/*      */             break;
/*      */           case 4096:
/*      */             try {
/*      */               setPenColor(this.currentStore, g2d, penObject);
/*      */               int pointCount = mr.elementAt(0);
/*      */               int bezierCount = (pointCount - 1) / 3;
/*      */               float _startX = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(1));
/*      */               float _startY = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(2));
/*      */               GeneralPath gp = new GeneralPath(1);
/*      */               gp.moveTo(_startX, _startY);
/*      */               for (int j = 0; j < bezierCount; j++) {
/*      */                 int j6 = j * 6;
/*      */                 float cp1X = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(j6 + 3));
/*      */                 float cp1Y = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(j6 + 4));
/*      */                 float cp2X = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(j6 + 5));
/*      */                 float cp2Y = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(j6 + 6));
/*      */                 float endX = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(j6 + 7));
/*      */                 float endY = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(j6 + 8));
/*      */                 gp.curveTo(cp1X, cp1Y, cp2X, cp2Y, endX, endY);
/*      */                 _startX = endX;
/*      */                 _startY = endY;
/*      */               } 
/*      */               g2d.setStroke(solid);
/*      */               g2d.draw(gp);
/*      */               this.firstEffectivePaint = false;
/*      */             } catch (Exception left) {
/*      */               Exception e;
/*      */             } 
/*      */             break;
/*      */           case 258:
/*      */             mode = mr.elementAt(0);
/*      */             this.opaque = (mode == 2);
/*      */             break;
/*      */           case 260:
/*      */             rop = mr.ElementAt(0).intValue();
/*      */             paint = null;
/*      */             ok = false;
/*      */             if (rop == 66.0F) {
/*      */               paint = Color.black;
/*      */               ok = true;
/*      */             } else if (rop == 1.6711778E7F) {
/*      */               paint = Color.white;
/*      */               ok = true;
/*      */             } else if (rop == 1.5728673E7F && brushObject >= 0) {
/*      */               paint = getStoredPaint(this.currentStore, brushObject);
/*      */               ok = true;
/*      */             } 
/*      */             if (ok) {
/*      */               if (paint != null) {
/*      */                 g2d.setPaint(paint);
/*      */                 break;
/*      */               } 
/*      */               setBrushPaint(this.currentStore, g2d, brushObject);
/*      */             } 
/*      */             break;
/*      */           case 1565:
/*      */             rop = mr.elementAt(0);
/*      */             height = this.scaleY * mr.elementAt(1);
/*      */             width = this.scaleX * mr.elementAt(2);
/*      */             left = this.scaleX * (this.vpX + this.xOffset + mr.elementAt(3));
/*      */             top = this.scaleY * (this.vpY + this.yOffset + mr.elementAt(4));
/*      */             paint = null;
/*      */             ok = false;
/*      */             if (rop == 66.0F) {
/*      */               paint = Color.black;
/*      */               ok = true;
/*      */             } else if (rop == 1.6711778E7F) {
/*      */               paint = Color.white;
/*      */               ok = true;
/*      */             } else if (rop == 1.5728673E7F && brushObject >= 0) {
/*      */               paint = getStoredPaint(this.currentStore, brushObject);
/*      */               ok = true;
/*      */             } 
/*      */             if (ok) {
/*      */               Color oldClr = g2d.getColor();
/*      */               if (paint != null) {
/*      */                 g2d.setPaint(paint);
/*      */               } else {
/*      */                 setBrushPaint(this.currentStore, g2d, brushObject);
/*      */               } 
/*      */               Rectangle2D.Float rec = new Rectangle2D.Float(left, top, width, height);
/*      */               g2d.fill(rec);
/*      */               g2d.setColor(oldClr);
/*      */             } 
/*      */             break;
/*      */           case 2881:
/*      */             height = mr.elementAt(1);
/*      */             width = mr.elementAt(2);
/*      */             sy = mr.elementAt(3);
/*      */             sx = mr.elementAt(4);
/*      */             dy = this.conv * this.currentStore.getVpWFactor() * (this.vpY + this.yOffset + mr.elementAt(7));
/*      */             dx = this.conv * this.currentStore.getVpHFactor() * (this.vpX + this.xOffset + mr.elementAt(8));
/*      */             heightDst = mr.elementAt(5);
/*      */             widthDst = mr.elementAt(6);
/*      */             widthDst = widthDst * this.conv * this.currentStore.getVpWFactor();
/*      */             heightDst = heightDst * this.conv * this.currentStore.getVpHFactor();
/*      */             bitmap = ((MetaRecord.ByteRecord)mr).bstr;
/*      */             img = getImage(bitmap, width, height);
/*      */             if (img != null)
/*      */               g2d.drawImage(img, (int)dx, (int)dy, (int)(dx + widthDst), (int)(dy + heightDst), sx, sy, sx + width, sy + height, this.bkgdColor, this.observer); 
/*      */             break;
/*      */           case 3907:
/*      */             height = mr.elementAt(1);
/*      */             width = mr.elementAt(2);
/*      */             sy = mr.elementAt(3);
/*      */             sx = mr.elementAt(4);
/*      */             dy = this.conv * this.currentStore.getVpWFactor() * (this.vpY + this.yOffset + mr.elementAt(7));
/*      */             dx = this.conv * this.currentStore.getVpHFactor() * (this.vpX + this.xOffset + mr.elementAt(8));
/*      */             heightDst = mr.elementAt(5);
/*      */             widthDst = mr.elementAt(6);
/*      */             widthDst = widthDst * this.conv * this.currentStore.getVpWFactor();
/*      */             heightDst = heightDst * this.conv * this.currentStore.getVpHFactor();
/*      */             bitmap = ((MetaRecord.ByteRecord)mr).bstr;
/*      */             img = getImage(bitmap, width, height);
/*      */             if (img != null) {
/*      */               if (this.opaque) {
/*      */                 g2d.drawImage(img, (int)dx, (int)dy, (int)(dx + widthDst), (int)(dy + heightDst), sx, sy, sx + width, sy + height, this.bkgdColor, this.observer);
/*      */                 break;
/*      */               } 
/*      */               g2d.drawImage(img, (int)dx, (int)dy, (int)(dx + widthDst), (int)(dy + heightDst), sx, sy, sx + width, sy + height, this.observer);
/*      */             } 
/*      */             break;
/*      */           case 2368:
/*      */             rop = mr.ElementAt(0).intValue();
/*      */             height = mr.ElementAt(1).intValue() * this.conv * this.currentStore.getVpWFactor();
/*      */             width = mr.ElementAt(2).intValue() * this.conv * this.currentStore.getVpHFactor();
/*      */             sy = mr.ElementAt(3).intValue();
/*      */             sx = mr.ElementAt(4).intValue();
/*      */             dy = this.conv * this.currentStore.getVpWFactor() * (this.vpY + this.yOffset + mr.ElementAt(5).intValue());
/*      */             dx = this.conv * this.currentStore.getVpHFactor() * (this.vpX + this.xOffset + mr.ElementAt(6).intValue());
/*      */             if (mr instanceof MetaRecord.ByteRecord) {
/*      */               byte[] bitmap = ((MetaRecord.ByteRecord)mr).bstr;
/*      */               BufferedImage img = getImage(bitmap);
/*      */               if (img != null) {
/*      */                 int withSrc = img.getWidth();
/*      */                 int heightSrc = img.getHeight();
/*      */                 if (this.opaque) {
/*      */                   g2d.drawImage(img, (int)dx, (int)dy, (int)(dx + width), (int)(dy + height), sx, sy, sx + withSrc, sy + heightSrc, this.bkgdColor, this.observer);
/*      */                   break;
/*      */                 } 
/*      */                 g2d.drawImage(img, (int)dx, (int)dy, (int)(dx + width), (int)(dy + height), sx, sy, sx + withSrc, sy + heightSrc, this.observer);
/*      */               } 
/*      */               break;
/*      */             } 
/*      */             if (this.opaque) {
/*      */               Color col = g2d.getColor();
/*      */               g2d.setColor(this.bkgdColor);
/*      */               g2d.fill(new Rectangle2D.Float(dx, dy, width, height));
/*      */               g2d.setColor(col);
/*      */             } 
/*      */             break;
/*      */           case 322:
/*      */             objIndex = 0;
/*      */             bitmap = ((MetaRecord.ByteRecord)mr).bstr;
/*      */             objIndex = addObjectAt(this.currentStore, 2, bitmap, objIndex);
/*      */             break;
/*      */         } 
/*      */       } 
/*      */     } 
/*      */   }
/*      */   
/*      */   private Paint getPaint(byte[] bit) {
/*      */     Dimension d = getImageDimension(bit);
/*      */     BufferedImage img = getImage(bit);
/*      */     Rectangle2D rec = new Rectangle2D.Float(0.0F, 0.0F, d.width, d.height);
/*      */     return new TexturePaint(img, rec);
/*      */   }
/*      */   
/*      */   private void drawString(int flag, Graphics2D g2d, AttributedCharacterIterator ati, float x, float y, TextLayout layout, WMFFont wmfFont, int align) {
/*      */     if (wmfFont.escape == 0) {
/*      */       if (flag != -1)
/*      */         fillTextBackground(-1, flag, g2d, x, y, 0.0F, layout); 
/*      */       float width = (float)layout.getBounds().getWidth();
/*      */       if (align == 6) {
/*      */         g2d.drawString(ati, x - width / 2.0F, y);
/*      */       } else if (align == 2) {
/*      */         g2d.drawString(ati, x - width, y);
/*      */       } else {
/*      */         g2d.drawString(ati, x, y);
/*      */       } 
/*      */     } else {
/*      */       AffineTransform tr = g2d.getTransform();
/*      */       float angle = -((float)(wmfFont.escape * Math.PI / 1800.0D));
/*      */       float width = (float)layout.getBounds().getWidth();
/*      */       float height = (float)layout.getBounds().getHeight();
/*      */       if (align == 6) {
/*      */         g2d.translate((-width / 2.0F), (height / 2.0F));
/*      */         g2d.rotate(angle, (x - width / 2.0F), y);
/*      */       } else if (align == 2) {
/*      */         g2d.translate((-width / 2.0F), (height / 2.0F));
/*      */         g2d.rotate(angle, (x - width), y);
/*      */       } else {
/*      */         g2d.translate(0.0D, (height / 2.0F));
/*      */         g2d.rotate(angle, x, y);
/*      */       } 
/*      */       if (flag != -1)
/*      */         fillTextBackground(align, flag, g2d, x, y, width, layout); 
/*      */       Stroke _st = g2d.getStroke();
/*      */       g2d.setStroke(textSolid);
/*      */       g2d.drawString(ati, x, y);
/*      */       g2d.setStroke(_st);
/*      */       g2d.setTransform(tr);
/*      */     } 
/*      */   }
/*      */   
/*      */   private void fillTextBackground(int align, int flag, Graphics2D g2d, float x, float y, float width, TextLayout layout) {
/*      */     float _x = x;
/*      */     if (align == 6) {
/*      */       _x = x - width / 2.0F;
/*      */     } else if (align == 2) {
/*      */       _x = x - width;
/*      */     } 
/*      */     if ((flag & 0x2) != 0) {
/*      */       Color c = g2d.getColor();
/*      */       AffineTransform tr = g2d.getTransform();
/*      */       g2d.setColor(this.bkgdColor);
/*      */       g2d.translate(_x, y);
/*      */       g2d.fill(layout.getBounds());
/*      */       g2d.setColor(c);
/*      */       g2d.setTransform(tr);
/*      */     } else if (this.opaque) {
/*      */       Color c = g2d.getColor();
/*      */       AffineTransform tr = g2d.getTransform();
/*      */       g2d.setColor(this.bkgdColor);
/*      */       g2d.translate(_x, y);
/*      */       g2d.fill(layout.getBounds());
/*      */       g2d.setColor(c);
/*      */       g2d.setTransform(tr);
/*      */     } 
/*      */   }
/*      */   
/*      */   private void drawPolyPolygon(Graphics2D g2d, List pols) {
/*      */     Iterator it = pols.iterator();
/*      */     while (it.hasNext()) {
/*      */       Polygon2D pol = (Polygon2D)it.next();
/*      */       g2d.draw(pol);
/*      */     } 
/*      */   }
/*      */   
/*      */   private void fillPolyPolygon(Graphics2D g2d, List pols) {
/*      */     if (pols.size() == 1) {
/*      */       g2d.fill((Polygon2D)pols.get(0));
/*      */     } else {
/*      */       GeneralPath path = new GeneralPath(0);
/*      */       for (int i = 0; i < pols.size(); i++) {
/*      */         Polygon2D pol = (Polygon2D)pols.get(i);
/*      */         path.append(pol, false);
/*      */       } 
/*      */       g2d.fill(path);
/*      */     } 
/*      */   }
/*      */   
/*      */   private void setStroke(Graphics2D g2d, int penStyle, float penWidth, float scale) {
/*      */     if (penWidth == 0.0F) {
/*      */       f = 1.0F;
/*      */     } else {
/*      */       f = penWidth;
/*      */     } 
/*      */     float _scale = Toolkit.getDefaultToolkit().getScreenResolution() / this.currentStore.getMetaFileUnitsPerInch();
/*      */     float factor = scale / _scale;
/*      */     float f = f * _scale * factor;
/*      */     _scale = this.currentStore.getWidthPixels() * 1.0F / 350.0F;
/*      */     if (penStyle == 0) {
/*      */       BasicStroke stroke = new BasicStroke(f, 0, 1);
/*      */       g2d.setStroke(stroke);
/*      */     } else if (penStyle == 2) {
/*      */       float[] dash = { 1.0F * _scale, 5.0F * _scale };
/*      */       BasicStroke basicStroke = new BasicStroke(f, 0, 1, 10.0F * _scale, dash, 0.0F);
/*      */       g2d.setStroke(basicStroke);
/*      */     } else if (penStyle == 1) {
/*      */       float[] dash = { 5.0F * _scale, 2.0F * _scale };
/*      */       BasicStroke basicStroke = new BasicStroke(f, 0, 1, 10.0F * _scale, dash, 0.0F);
/*      */       g2d.setStroke(basicStroke);
/*      */     } else if (penStyle == 3) {
/*      */       float[] dash = { 5.0F * _scale, 2.0F * _scale, 1.0F * _scale, 2.0F * _scale };
/*      */       BasicStroke basicStroke = new BasicStroke(f, 0, 1, 10.0F * _scale, dash, 0.0F);
/*      */       g2d.setStroke(basicStroke);
/*      */     } else if (penStyle == 4) {
/*      */       float[] dash = { 5.0F * _scale, 2.0F * _scale, 1.0F * _scale, 2.0F * _scale, 1.0F * _scale, 2.0F * _scale };
/*      */       BasicStroke basicStroke = new BasicStroke(f, 0, 1, 15.0F * _scale, dash, 0.0F);
/*      */       g2d.setStroke(basicStroke);
/*      */     } else {
/*      */       BasicStroke basicStroke = new BasicStroke(f, 0, 1);
/*      */       g2d.setStroke(basicStroke);
/*      */     } 
/*      */   }
/*      */   
/*      */   private void setPenColor(WMFRecordStore currentStore, Graphics2D g2d, int penObject) {
/*      */     if (penObject >= 0) {
/*      */       GdiObject gdiObj = currentStore.getObject(penObject);
/*      */       g2d.setColor((Color)gdiObj.obj);
/*      */       penObject = -1;
/*      */     } 
/*      */   }
/*      */   
/*      */   private int getHorizontalAlignement(int align) {
/*      */     int v = align;
/*      */     v %= 24;
/*      */     v %= 8;
/*      */     if (v >= 6)
/*      */       return 6; 
/*      */     if (v >= 2)
/*      */       return 2; 
/*      */     return 0;
/*      */   }
/*      */   
/*      */   private void setBrushPaint(WMFRecordStore currentStore, Graphics2D g2d, int brushObject) {
/*      */     if (brushObject >= 0) {
/*      */       GdiObject gdiObj = currentStore.getObject(brushObject);
/*      */       if (gdiObj.obj instanceof Color) {
/*      */         g2d.setColor((Color)gdiObj.obj);
/*      */       } else if (gdiObj.obj instanceof Paint) {
/*      */         g2d.setPaint((Paint)gdiObj.obj);
/*      */       } else {
/*      */         g2d.setPaint(getPaint((byte[])gdiObj.obj));
/*      */       } 
/*      */       brushObject = -1;
/*      */     } 
/*      */   }
/*      */   
/*      */   private Paint getStoredPaint(WMFRecordStore currentStore, int object) {
/*      */     if (object >= 0) {
/*      */       GdiObject gdiObj = currentStore.getObject(object);
/*      */       if (gdiObj.obj instanceof Paint)
/*      */         return (Paint)gdiObj.obj; 
/*      */       return getPaint((byte[])gdiObj.obj);
/*      */     } 
/*      */     return null;
/*      */   }
/*      */   
/*      */   private void paint(int brushObject, int penObject, Shape shape, Graphics2D g2d) {
/*      */     if (brushObject >= 0) {
/*      */       Paint paint = getStoredPaint(this.currentStore, brushObject);
/*      */       if (!this.firstEffectivePaint || !paint.equals(Color.white)) {
/*      */         setBrushPaint(this.currentStore, g2d, brushObject);
/*      */         g2d.fill(shape);
/*      */         this.firstEffectivePaint = false;
/*      */       } 
/*      */     } 
/*      */     if (penObject >= 0) {
/*      */       Paint paint = getStoredPaint(this.currentStore, penObject);
/*      */       if (!this.firstEffectivePaint || !paint.equals(Color.white)) {
/*      */         setPenColor(this.currentStore, g2d, penObject);
/*      */         g2d.draw(shape);
/*      */         this.firstEffectivePaint = false;
/*      */       } 
/*      */     } 
/*      */   }
/*      */   
/*      */   private void paintWithPen(int penObject, Shape shape, Graphics2D g2d) {
/*      */     if (penObject >= 0) {
/*      */       Paint paint = getStoredPaint(this.currentStore, penObject);
/*      */       if (!this.firstEffectivePaint || !paint.equals(Color.white)) {
/*      */         setPenColor(this.currentStore, g2d, penObject);
/*      */         g2d.draw(shape);
/*      */         this.firstEffectivePaint = false;
/*      */       } 
/*      */     } 
/*      */   }
/*      */   
/*      */   private float getVerticalAlignmentValue(TextLayout layout, int vertAlign) {
/*      */     if (vertAlign == 8)
/*      */       return -layout.getDescent(); 
/*      */     if (vertAlign == 0)
/*      */       return layout.getAscent(); 
/*      */     return 0.0F;
/*      */   }
/*      */   
/*      */   public WMFRecordStore getRecordStore() { return this.currentStore; }
/*      */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-transcoder.jar!\org\apache\batik\transcoder\wmf\tosvg\WMFPainter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */