/*     */ package org.apache.batik.transcoder.wmf.tosvg;
/*     */ 
/*     */ import java.io.DataInputStream;
/*     */ import java.io.IOException;
/*     */ import java.net.URL;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class WMFRecordStore
/*     */   extends AbstractWMFReader
/*     */ {
/*     */   private URL url;
/*     */   protected int numRecords;
/*     */   protected float vpX;
/*     */   protected float vpY;
/*     */   protected List records;
/*     */   private boolean _bext;
/*     */   
/*     */   public WMFRecordStore() {
/*  43 */     this._bext = true;
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  48 */     reset();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void reset() {
/*  55 */     this.numRecords = 0;
/*  56 */     this.vpX = 0.0F;
/*  57 */     this.vpY = 0.0F;
/*  58 */     this.vpW = 1000;
/*  59 */     this.vpH = 1000;
/*  60 */     this.scaleX = 1.0F;
/*  61 */     this.scaleY = 1.0F;
/*  62 */     this.scaleXY = 1.0F;
/*  63 */     this.inch = 84;
/*  64 */     this.records = new ArrayList(20);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected boolean readRecords(DataInputStream is) throws IOException {
/*  72 */     short functionId = 1;
/*  73 */     int recSize = 0;
/*     */ 
/*     */     
/*  76 */     this.numRecords = 0;
/*     */     
/*  78 */     while (functionId > 0) {
/*  79 */       String str; int i; byte[] lfFaceName; int len, i, lfPitchAndFamily, i, lfQuality; byte[] bstr, bitmap; int i, lfClipPrecision; byte[] bitmap; int len, len, lfOutPrecision, dx, y2, len, dy, dx, x2, lfCharSet, dy, left, widthDst, lfStrikeOut, dx, y1, lfUnderline, heightDst, i, x1, dy, widthDst, top, heightDst, offset, right, sx, left, flags, lfItalic, xVal, width; boolean clipped; int flags, sx, read, lfWeight, top, bottom, yVal, i, sy, blue, flags, top, height, i, green, left, sy, xnum, left, blue, lfOrientation, blue, i, right, bottom, flag, hdc, xstart, i, widthSrc, xdenom, heightSrc, green, width, bottom; byte[] bstr; int green, top, lenText, ystart, right, widthSrc, lfEscapement, red, ptCount; byte[] bitmap; int sx, colorref, ynum, el_width, pts[], usage, x, lfWidth, heightSrc, red, width, len, red, right, top, x, xVal, height, read, sy, i, xend, rop, i, ydenom, height, el_height, width, left, y, mode, lfHeight, count, colorref, mode, colorref, count, mode, j, yend, len, mode, type, align, mode, y, mapmode, bottom, yVal; recSize = readInt(is);
/*     */       
/*  81 */       recSize -= 3;
/*  82 */       functionId = readShort(is);
/*  83 */       if (functionId <= 0) {
/*     */         break;
/*     */       }
/*  86 */       MetaRecord mr = new MetaRecord();
/*  87 */       switch (functionId) {
/*     */         case 259:
/*  89 */           mr.numPoints = recSize;
/*  90 */           mr.functionId = functionId;
/*     */           
/*  92 */           mapmode = readShort(is);
/*  93 */           if (mapmode == 8) this.isotropic = false; 
/*  94 */           mr.addElement(mapmode);
/*  95 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */         
/*     */         case 1583:
/* 100 */           for (i = 0; i < recSize; i++)
/* 101 */             short recData = readShort(is); 
/* 102 */           this.numRecords--;
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 2610:
/* 108 */           yVal = readShort(is) * this.ySign;
/* 109 */           xVal = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 110 */           lenText = readShort(is);
/* 111 */           flag = readShort(is);
/* 112 */           read = 4;
/* 113 */           clipped = false;
/* 114 */           x1 = 0; y1 = 0; x2 = 0; y2 = 0;
/*     */ 
/*     */           
/* 117 */           if ((flag & 0x4) != 0) {
/* 118 */             x1 = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 119 */             y1 = readShort(is) * this.ySign;
/* 120 */             x2 = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 121 */             y2 = readShort(is) * this.ySign;
/* 122 */             read += 4;
/* 123 */             clipped = true;
/*     */           } 
/* 125 */           bstr = new byte[lenText];
/* 126 */           i = 0;
/* 127 */           for (; i < lenText; i++) {
/* 128 */             bstr[i] = is.readByte();
/*     */           }
/* 130 */           read += (lenText + 1) / 2;
/*     */ 
/*     */ 
/*     */           
/* 134 */           if (lenText % 2 != 0) is.readByte();
/*     */           
/* 136 */           if (read < recSize) for (int j = read; j < recSize; ) { readShort(is); j++; }
/*     */           
/*     */ 
/*     */ 
/*     */           
/* 141 */           mr = new MetaRecord.ByteRecord(bstr);
/* 142 */           mr.numPoints = recSize;
/* 143 */           mr.functionId = functionId;
/*     */           
/* 145 */           mr.addElement(xVal);
/* 146 */           mr.addElement(yVal);
/* 147 */           mr.addElement(flag);
/* 148 */           if (clipped) {
/* 149 */             mr.addElement(x1);
/* 150 */             mr.addElement(y1);
/* 151 */             mr.addElement(x2);
/* 152 */             mr.addElement(y2);
/*     */           } 
/* 154 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 1313:
/* 160 */           len = readShort(is);
/* 161 */           read = 1;
/* 162 */           bstr = new byte[len];
/* 163 */           for (i = 0; i < len; i++) {
/* 164 */             bstr[i] = is.readByte();
/*     */           }
/*     */ 
/*     */ 
/*     */           
/* 169 */           if (len % 2 != 0) is.readByte(); 
/* 170 */           read += (len + 1) / 2;
/*     */           
/* 172 */           yVal = readShort(is) * this.ySign;
/* 173 */           xVal = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 174 */           read += 2;
/*     */           
/* 176 */           if (read < recSize) for (int j = read; j < recSize; ) { readShort(is); j++; }
/*     */           
/*     */ 
/*     */ 
/*     */           
/* 181 */           mr = new MetaRecord.ByteRecord(bstr);
/* 182 */           mr.numPoints = recSize;
/* 183 */           mr.functionId = functionId;
/*     */           
/* 185 */           mr.addElement(xVal);
/* 186 */           mr.addElement(yVal);
/* 187 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */ 
/*     */         
/*     */         case 763:
/* 194 */           lfHeight = readShort(is);
/* 195 */           lfWidth = readShort(is);
/* 196 */           lfEscapement = readShort(is);
/* 197 */           lfOrientation = readShort(is);
/* 198 */           lfWeight = readShort(is);
/*     */           
/* 200 */           lfItalic = is.readByte();
/* 201 */           lfUnderline = is.readByte();
/* 202 */           lfStrikeOut = is.readByte();
/* 203 */           lfCharSet = is.readByte() & 0xFF;
/*     */           
/* 205 */           lfOutPrecision = is.readByte();
/* 206 */           lfClipPrecision = is.readByte();
/* 207 */           lfQuality = is.readByte();
/* 208 */           lfPitchAndFamily = is.readByte();
/*     */ 
/*     */ 
/*     */           
/* 212 */           len = 2 * (recSize - 9);
/* 213 */           lfFaceName = new byte[len];
/*     */           
/* 215 */           for (i = 0; i < len; ) { lfFaceName[i] = is.readByte(); i++; }
/*     */           
/* 217 */           str = new String(lfFaceName);
/*     */           
/* 219 */           mr = new MetaRecord.StringRecord(str);
/* 220 */           mr.numPoints = recSize;
/* 221 */           mr.functionId = functionId;
/*     */           
/* 223 */           mr.addElement(lfHeight);
/* 224 */           mr.addElement(lfItalic);
/* 225 */           mr.addElement(lfWeight);
/* 226 */           mr.addElement(lfCharSet);
/* 227 */           mr.addElement(lfUnderline);
/* 228 */           mr.addElement(lfStrikeOut);
/* 229 */           mr.addElement(lfOrientation);
/*     */           
/* 231 */           mr.addElement(lfEscapement);
/* 232 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */         
/*     */         case 523:
/*     */         case 524:
/*     */         case 525:
/*     */         case 526:
/* 240 */           mr.numPoints = recSize;
/* 241 */           mr.functionId = functionId;
/*     */           
/* 243 */           height = readShort(is);
/* 244 */           width = readShort(is);
/*     */           
/* 246 */           if (width < 0) {
/* 247 */             width = -width;
/* 248 */             this.xSign = -1;
/*     */           } 
/* 250 */           if (height < 0) {
/* 251 */             height = -height;
/* 252 */             this.ySign = -1;
/*     */           } 
/*     */           
/* 255 */           mr.addElement((int)(width * this.scaleXY));
/* 256 */           mr.addElement(height);
/* 257 */           this.records.add(mr);
/*     */           
/* 259 */           if (this._bext && functionId == 524) {
/* 260 */             this.vpW = width;
/* 261 */             this.vpH = height;
/* 262 */             if (!this.isotropic) this.scaleXY = this.vpW / this.vpH; 
/* 263 */             this.vpW = (int)(this.vpW * this.scaleXY);
/* 264 */             this._bext = false;
/*     */           } 
/*     */ 
/*     */           
/* 268 */           if (!this.isAldus) {
/* 269 */             this.width = this.vpW;
/* 270 */             this.height = this.vpH;
/*     */           } 
/*     */           break;
/*     */ 
/*     */         
/*     */         case 527:
/*     */         case 529:
/* 277 */           mr.numPoints = recSize;
/* 278 */           mr.functionId = functionId;
/*     */           
/* 280 */           y = readShort(is) * this.ySign;
/* 281 */           x = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 282 */           mr.addElement(x);
/* 283 */           mr.addElement(y);
/* 284 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */         
/*     */         case 1040:
/*     */         case 1042:
/* 290 */           mr.numPoints = recSize;
/* 291 */           mr.functionId = functionId;
/*     */           
/* 293 */           ydenom = readShort(is);
/* 294 */           ynum = readShort(is);
/* 295 */           xdenom = readShort(is);
/* 296 */           xnum = readShort(is);
/* 297 */           mr.addElement(xdenom);
/* 298 */           mr.addElement(ydenom);
/* 299 */           mr.addElement(xnum);
/* 300 */           mr.addElement(ynum);
/* 301 */           this.records.add(mr);
/* 302 */           this.scaleX = this.scaleX * xdenom / xnum;
/* 303 */           this.scaleY = this.scaleY * ydenom / ynum;
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 764:
/* 309 */           mr.numPoints = recSize;
/* 310 */           mr.functionId = functionId;
/*     */ 
/*     */           
/* 313 */           mr.addElement(readShort(is));
/*     */           
/* 315 */           colorref = readInt(is);
/* 316 */           red = colorref & 0xFF;
/* 317 */           green = (colorref & 0xFF00) >> 8;
/* 318 */           blue = (colorref & 0xFF0000) >> 16;
/* 319 */           flags = (colorref & 0x3000000) >> 24;
/* 320 */           mr.addElement(red);
/* 321 */           mr.addElement(green);
/* 322 */           mr.addElement(blue);
/*     */ 
/*     */           
/* 325 */           mr.addElement(readShort(is));
/*     */           
/* 327 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 762:
/* 333 */           mr.numPoints = recSize;
/* 334 */           mr.functionId = functionId;
/*     */ 
/*     */           
/* 337 */           mr.addElement(readShort(is));
/*     */           
/* 339 */           width = readInt(is);
/* 340 */           colorref = readInt(is);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */           
/* 348 */           if (recSize == 6) readShort(is);
/*     */           
/* 350 */           red = colorref & 0xFF;
/* 351 */           green = (colorref & 0xFF00) >> 8;
/* 352 */           blue = (colorref & 0xFF0000) >> 16;
/* 353 */           flags = (colorref & 0x3000000) >> 24;
/*     */           
/* 355 */           mr.addElement(red);
/* 356 */           mr.addElement(green);
/* 357 */           mr.addElement(blue);
/*     */ 
/*     */           
/* 360 */           mr.addElement(width);
/*     */           
/* 362 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 302:
/* 368 */           mr.numPoints = recSize;
/* 369 */           mr.functionId = functionId;
/* 370 */           align = readShort(is);
/*     */           
/* 372 */           if (recSize > 1) for (int i = 1; i < recSize; ) { readShort(is); i++; }
/* 373 */               mr.addElement(align);
/* 374 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 513:
/*     */         case 521:
/* 381 */           mr.numPoints = recSize;
/* 382 */           mr.functionId = functionId;
/*     */           
/* 384 */           colorref = readInt(is);
/* 385 */           red = colorref & 0xFF;
/* 386 */           green = (colorref & 0xFF00) >> 8;
/* 387 */           blue = (colorref & 0xFF0000) >> 16;
/* 388 */           flags = (colorref & 0x3000000) >> 24;
/* 389 */           mr.addElement(red);
/* 390 */           mr.addElement(green);
/* 391 */           mr.addElement(blue);
/* 392 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 531:
/*     */         case 532:
/* 399 */           mr.numPoints = recSize;
/* 400 */           mr.functionId = functionId;
/*     */           
/* 402 */           y = readShort(is) * this.ySign;
/* 403 */           x = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 404 */           mr.addElement(x);
/* 405 */           mr.addElement(y);
/* 406 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 262:
/* 412 */           mr.numPoints = recSize;
/* 413 */           mr.functionId = functionId;
/*     */           
/* 415 */           mode = readShort(is);
/*     */           
/* 417 */           if (recSize > 1) for (int i = 1; i < recSize; ) { readShort(is); i++; }
/* 418 */               mr.addElement(mode);
/* 419 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 1336:
/* 425 */           mr.numPoints = recSize;
/* 426 */           mr.functionId = functionId;
/*     */           
/* 428 */           count = readShort(is);
/* 429 */           pts = new int[count];
/* 430 */           ptCount = 0;
/* 431 */           for (i = 0; i < count; i++) {
/* 432 */             pts[i] = readShort(is);
/* 433 */             ptCount += pts[i];
/*     */           } 
/* 435 */           mr.addElement(count);
/*     */           
/* 437 */           for (i = 0; i < count; i++) {
/* 438 */             mr.addElement(pts[i]);
/*     */           }
/* 440 */           offset = count + 1;
/* 441 */           for (i = 0; i < count; i++) {
/* 442 */             int nPoints = pts[i];
/* 443 */             for (int j = 0; j < nPoints; j++) {
/* 444 */               mr.addElement((int)((readShort(is) * this.xSign) * this.scaleXY));
/* 445 */               mr.addElement(readShort(is) * this.ySign);
/*     */             } 
/*     */           } 
/* 448 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 804:
/*     */         case 805:
/* 455 */           mr.numPoints = recSize;
/* 456 */           mr.functionId = functionId;
/*     */           
/* 458 */           count = readShort(is);
/* 459 */           mr.addElement(count);
/* 460 */           for (i = 0; i < count; i++) {
/* 461 */             mr.addElement((int)((readShort(is) * this.xSign) * this.scaleXY));
/* 462 */             mr.addElement(readShort(is) * this.ySign);
/*     */           } 
/* 464 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 1046:
/*     */         case 1048:
/*     */         case 1051:
/* 472 */           mr.numPoints = recSize;
/* 473 */           mr.functionId = functionId;
/*     */           
/* 475 */           bottom = readShort(is) * this.ySign;
/* 476 */           right = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 477 */           top = readShort(is) * this.ySign;
/* 478 */           left = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 479 */           mr.addElement(left);
/* 480 */           mr.addElement(top);
/* 481 */           mr.addElement(right);
/* 482 */           mr.addElement(bottom);
/* 483 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */         
/*     */         case 1791:
/* 488 */           mr.numPoints = recSize;
/* 489 */           mr.functionId = functionId;
/* 490 */           left = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 491 */           top = readShort(is) * this.ySign;
/* 492 */           right = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 493 */           bottom = readShort(is) * this.ySign;
/* 494 */           mr.addElement(left);
/* 495 */           mr.addElement(top);
/* 496 */           mr.addElement(right);
/* 497 */           mr.addElement(bottom);
/* 498 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */         
/*     */         case 1564:
/* 503 */           mr.numPoints = recSize;
/* 504 */           mr.functionId = functionId;
/*     */           
/* 506 */           el_height = readShort(is) * this.ySign;
/* 507 */           el_width = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 508 */           bottom = readShort(is) * this.ySign;
/* 509 */           right = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 510 */           top = readShort(is) * this.ySign;
/* 511 */           left = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 512 */           mr.addElement(left);
/* 513 */           mr.addElement(top);
/* 514 */           mr.addElement(right);
/* 515 */           mr.addElement(bottom);
/* 516 */           mr.addElement(el_width);
/* 517 */           mr.addElement(el_height);
/* 518 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 2071:
/*     */         case 2074:
/* 525 */           mr.numPoints = recSize;
/* 526 */           mr.functionId = functionId;
/*     */           
/* 528 */           yend = readShort(is) * this.ySign;
/* 529 */           xend = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 530 */           ystart = readShort(is) * this.ySign;
/* 531 */           xstart = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 532 */           bottom = readShort(is) * this.ySign;
/* 533 */           right = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 534 */           top = readShort(is) * this.ySign;
/* 535 */           left = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 536 */           mr.addElement(left);
/* 537 */           mr.addElement(top);
/* 538 */           mr.addElement(right);
/* 539 */           mr.addElement(bottom);
/* 540 */           mr.addElement(xstart);
/* 541 */           mr.addElement(ystart);
/* 542 */           mr.addElement(xend);
/* 543 */           mr.addElement(yend);
/* 544 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */ 
/*     */         
/*     */         case 1565:
/* 551 */           mr.numPoints = recSize;
/* 552 */           mr.functionId = functionId;
/*     */           
/* 554 */           rop = readInt(is);
/* 555 */           height = readShort(is) * this.ySign;
/* 556 */           width = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 557 */           left = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 558 */           top = readShort(is) * this.ySign;
/*     */           
/* 560 */           mr.addElement(rop);
/* 561 */           mr.addElement(height);
/* 562 */           mr.addElement(width);
/* 563 */           mr.addElement(top);
/* 564 */           mr.addElement(left);
/*     */           
/* 566 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 258:
/* 572 */           mr.numPoints = recSize;
/* 573 */           mr.functionId = functionId;
/*     */           
/* 575 */           mode = readShort(is);
/* 576 */           mr.addElement(mode);
/*     */           
/* 578 */           if (recSize > 1) for (int i = 1; i < recSize; ) { readShort(is); i++; }
/* 579 */               this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */ 
/*     */         
/*     */         case 260:
/* 586 */           mr.numPoints = recSize;
/* 587 */           mr.functionId = functionId;
/*     */ 
/*     */ 
/*     */           
/* 591 */           if (recSize == 1) { int rop = readShort(is); }
/* 592 */           else { mode = readInt(is); }
/*     */           
/* 594 */           mr.addElement(mode);
/* 595 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 2881:
/* 601 */           mode = is.readInt() & 0xFF;
/* 602 */           heightSrc = readShort(is) * this.ySign;
/* 603 */           widthSrc = readShort(is) * this.xSign;
/* 604 */           sy = readShort(is) * this.ySign;
/* 605 */           sx = readShort(is) * this.xSign;
/* 606 */           heightDst = readShort(is) * this.ySign;
/* 607 */           widthDst = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 608 */           dy = readShort(is) * this.ySign;
/* 609 */           dx = (int)((readShort(is) * this.xSign) * this.scaleXY);
/*     */           
/* 611 */           len = 2 * recSize - 20;
/* 612 */           bitmap = new byte[len];
/* 613 */           for (i = 0; i < len; ) { bitmap[i] = is.readByte(); i++; }
/*     */           
/* 615 */           mr = new MetaRecord.ByteRecord(bitmap);
/* 616 */           mr.numPoints = recSize;
/* 617 */           mr.functionId = functionId;
/* 618 */           mr.addElement(mode);
/* 619 */           mr.addElement(heightSrc);
/* 620 */           mr.addElement(widthSrc);
/* 621 */           mr.addElement(sy);
/* 622 */           mr.addElement(sx);
/* 623 */           mr.addElement(heightDst);
/* 624 */           mr.addElement(widthDst);
/* 625 */           mr.addElement(dy);
/* 626 */           mr.addElement(dx);
/* 627 */           this.records.add(mr);
/*     */           break;
/*     */         
/*     */         case 3907:
/* 631 */           mode = is.readInt() & 0xFF;
/* 632 */           usage = readShort(is);
/* 633 */           heightSrc = readShort(is) * this.ySign;
/* 634 */           widthSrc = readShort(is) * this.xSign;
/* 635 */           sy = readShort(is) * this.ySign;
/* 636 */           sx = readShort(is) * this.xSign;
/* 637 */           heightDst = readShort(is) * this.ySign;
/* 638 */           widthDst = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 639 */           dy = readShort(is) * this.ySign;
/* 640 */           dx = (int)((readShort(is) * this.xSign) * this.scaleXY);
/*     */           
/* 642 */           len = 2 * recSize - 22;
/* 643 */           bitmap = new byte[len];
/* 644 */           for (i = 0; i < len; ) { bitmap[i] = is.readByte(); i++; }
/*     */           
/* 646 */           mr = new MetaRecord.ByteRecord(bitmap);
/* 647 */           mr.numPoints = recSize;
/* 648 */           mr.functionId = functionId;
/* 649 */           mr.addElement(mode);
/* 650 */           mr.addElement(heightSrc);
/* 651 */           mr.addElement(widthSrc);
/* 652 */           mr.addElement(sy);
/* 653 */           mr.addElement(sx);
/* 654 */           mr.addElement(heightDst);
/* 655 */           mr.addElement(widthDst);
/* 656 */           mr.addElement(dy);
/* 657 */           mr.addElement(dx);
/* 658 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 2368:
/* 664 */           mode = is.readInt() & 0xFF;
/* 665 */           sy = readShort(is);
/* 666 */           sx = readShort(is);
/* 667 */           hdc = readShort(is);
/* 668 */           height = readShort(is);
/* 669 */           width = (int)((readShort(is) * this.xSign) * this.scaleXY);
/* 670 */           dy = readShort(is);
/* 671 */           dx = (int)((readShort(is) * this.xSign) * this.scaleXY);
/*     */           
/* 673 */           len = 2 * recSize - 18;
/* 674 */           if (len > 0) {
/* 675 */             byte[] bitmap = new byte[len];
/* 676 */             for (int i = 0; i < len; i++)
/* 677 */               bitmap[i] = is.readByte(); 
/* 678 */             mr = new MetaRecord.ByteRecord(bitmap);
/* 679 */             mr.numPoints = recSize;
/* 680 */             mr.functionId = functionId;
/*     */           } else {
/*     */             
/* 683 */             mr.numPoints = recSize;
/* 684 */             mr.functionId = functionId;
/* 685 */             for (int i = 0; i < len; ) { is.readByte(); i++; }
/*     */           
/*     */           } 
/* 688 */           mr.addElement(mode);
/* 689 */           mr.addElement(height);
/* 690 */           mr.addElement(width);
/* 691 */           mr.addElement(sy);
/* 692 */           mr.addElement(sx);
/* 693 */           mr.addElement(dy);
/* 694 */           mr.addElement(dx);
/* 695 */           this.records.add(mr);
/*     */           break;
/*     */ 
/*     */ 
/*     */         
/*     */         case 322:
/* 701 */           type = is.readInt() & 0xFF;
/* 702 */           len = 2 * recSize - 4;
/* 703 */           bitmap = new byte[len];
/* 704 */           for (i = 0; i < len; ) { bitmap[i] = is.readByte(); i++; }
/*     */           
/* 706 */           mr = new MetaRecord.ByteRecord(bitmap);
/* 707 */           mr.numPoints = recSize;
/* 708 */           mr.functionId = functionId;
/* 709 */           mr.addElement(type);
/* 710 */           this.records.add(mr);
/*     */           break;
/*     */         
/*     */         default:
/* 714 */           mr.numPoints = recSize;
/* 715 */           mr.functionId = functionId;
/*     */           
/* 717 */           for (j = 0; j < recSize; j++) {
/* 718 */             mr.addElement(readShort(is));
/*     */           }
/* 720 */           this.records.add(mr);
/*     */           break;
/*     */       } 
/*     */ 
/*     */       
/* 725 */       this.numRecords++;
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 731 */     if (!this.isAldus) {
/* 732 */       this.right = (int)this.vpX;
/* 733 */       this.left = (int)(this.vpX + this.vpW);
/* 734 */       this.top = (int)this.vpY;
/* 735 */       this.bottom = (int)(this.vpY + this.vpH);
/*     */     } 
/* 737 */     setReading(false);
/* 738 */     return true;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 745 */   public URL getUrl() { return this.url; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 752 */   public void setUrl(URL newUrl) { this.url = newUrl; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 759 */   public MetaRecord getRecord(int idx) { return (MetaRecord)this.records.get(idx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 766 */   public int getNumRecords() { return this.numRecords; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 773 */   public float getVpX() { return this.vpX; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 780 */   public float getVpY() { return this.vpY; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 787 */   public void setVpX(float newValue) { this.vpX = newValue; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 794 */   public void setVpY(float newValue) { this.vpY = newValue; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-transcoder.jar!\org\apache\batik\transcoder\wmf\tosvg\WMFRecordStore.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */